import classnames from 'classnames';
import React from 'react';

function styleInject(css, ref) {
  if ( ref === void 0 ) ref = {};
  var insertAt = ref.insertAt;

  if (!css || typeof document === 'undefined') { return; }

  var head = document.head || document.getElementsByTagName('head')[0];
  var style = document.createElement('style');
  style.type = 'text/css';

  if (insertAt === 'top') {
    if (head.firstChild) {
      head.insertBefore(style, head.firstChild);
    } else {
      head.appendChild(style);
    }
  } else {
    head.appendChild(style);
  }

  if (style.styleSheet) {
    style.styleSheet.cssText = css;
  } else {
    style.appendChild(document.createTextNode(css));
  }
}

var css = ".ph-audio-block {\n  position: relative;\n  width: 100%;\n  height: 1.12rem;\n  padding-left: 0.8rem;\n  margin-left: 0.21333rem;\n  color: #fff;\n  background-color: #ffc21e;\n  border-radius: 0.16rem;\n}\n.ph-audio-block.is-pad {\n  height: 0.50781rem;\n  padding-left: 0.29297rem;\n  margin-left: 0.11719rem;\n  border-radius: 0.05859rem;\n}\n.ph-audio-block.is-pad::before {\n  width: 0.14648rem;\n  height: 0.14648rem;\n  border-radius: 0.0293rem;\n  -webkit-transform: translate(-40%, -50%) rotate(45deg);\n          transform: translate(-40%, -50%) rotate(45deg);\n}\n.ph-audio-block.is-pad .duration-text {\n  height: 0.50781rem;\n  margin-left: 0.07813rem;\n  font-size: 0.19531rem;\n  line-height: 0.50781rem;\n}\n.ph-audio-block.is-pad .animation-container {\n  width: 0.19531rem;\n  height: 0.21484rem;\n  margin-left: 0.11719rem;\n}\n.ph-audio-block.is-pad .animation-container .animation-item {\n  width: 0.01953rem;\n  height: 0.13672rem;\n  margin-top: 0.01953rem;\n  margin-left: 0.01953rem;\n  border-radius: 0.01953rem;\n}\n.ph-audio-block.on-play .animation-item {\n  -webkit-animation: 0.5s audio-item-animation infinite;\n          animation: 0.5s audio-item-animation infinite;\n}\n.ph-audio-block.on-play .animation-item:nth-child(1) {\n  -webkit-animation-delay: 0.1s;\n          animation-delay: 0.1s;\n}\n.ph-audio-block.on-play .animation-item:nth-child(2) {\n  -webkit-animation-delay: 0.2s;\n          animation-delay: 0.2s;\n}\n.ph-audio-block.on-play .animation-item:nth-child(3) {\n  -webkit-animation-delay: 0.3s;\n          animation-delay: 0.3s;\n}\n.ph-audio-block.on-play .animation-item:nth-child(4) {\n  -webkit-animation-delay: 0.4s;\n          animation-delay: 0.4s;\n}\n.ph-audio-block::before {\n  content: \"\";\n  position: absolute;\n  top: 50%;\n  left: 0;\n  z-index: 0;\n  width: 0.26667rem;\n  height: 0.26667rem;\n  background-color: #ffc21e;\n  border-radius: 0.08rem;\n  -webkit-transform: translate(-40%, -50%) rotate(45deg);\n          transform: translate(-40%, -50%) rotate(45deg);\n}\n.ph-audio-block .animation-container {\n  position: absolute;\n  top: 50%;\n  left: 0;\n  z-index: 1;\n  display: inline-block;\n  width: 0.48rem;\n  height: 0.48rem;\n  margin-left: 0.32rem;\n  -webkit-transform: translateY(-50%);\n          transform: translateY(-50%);\n}\n.ph-audio-block .animation-container .animation-item {\n  display: inline-block;\n  width: 0.05333rem;\n  height: 0.37333rem;\n  margin-top: 0.05333rem;\n  margin-left: 0.05333rem;\n  vertical-align: top;\n  background-color: #fff;\n  border-radius: 0.05333rem;\n}\n.ph-audio-block .animation-container .animation-item:nth-child(1) {\n  -webkit-transform: scale(1, 0.4);\n          transform: scale(1, 0.4);\n}\n.ph-audio-block .animation-container .animation-item:nth-child(2) {\n  -webkit-transform: scale(1, 0.8);\n          transform: scale(1, 0.8);\n}\n.ph-audio-block .animation-container .animation-item:nth-child(3) {\n  -webkit-transform: scale(1, 1);\n          transform: scale(1, 1);\n}\n.ph-audio-block .animation-container .animation-item:nth-child(4) {\n  -webkit-transform: scale(1, 0.6);\n          transform: scale(1, 0.6);\n}\n.ph-audio-block .duration-text {\n  display: inline-block;\n  height: 1.12rem;\n  margin-left: 0.21333rem;\n  font-size: 0.53333rem;\n  line-height: 1.12rem;\n  vertical-align: top;\n}\n@-webkit-keyframes audio-item-animation {\n  0% {\n    -webkit-transform: scale(1, 1);\n            transform: scale(1, 1);\n  }\n  25% {\n    -webkit-transform: scale(1, 0.75);\n            transform: scale(1, 0.75);\n  }\n  50% {\n    -webkit-transform: scale(1, 0.5);\n            transform: scale(1, 0.5);\n  }\n  75% {\n    -webkit-transform: scale(1, 0.25);\n            transform: scale(1, 0.25);\n  }\n}\n@keyframes audio-item-animation {\n  0% {\n    -webkit-transform: scale(1, 1);\n            transform: scale(1, 1);\n  }\n  25% {\n    -webkit-transform: scale(1, 0.75);\n            transform: scale(1, 0.75);\n  }\n  50% {\n    -webkit-transform: scale(1, 0.5);\n            transform: scale(1, 0.5);\n  }\n  75% {\n    -webkit-transform: scale(1, 0.25);\n            transform: scale(1, 0.25);\n  }\n}\n";
styleInject(css);

var Status;
(function (Status) {
    Status[Status["PLAY"] = 0] = "PLAY";
    Status[Status["STOP"] = 1] = "STOP";
})(Status || (Status = {}));
class AudioBlock extends React.Component {
    constructor() {
        super(...arguments);
        this.audio = null;
        this.state = { status: Status.STOP };
        this.clickHandler = () => {
            const { status } = this.state;
            const { onClick } = this.props;
            const audio = this.audio;
            if (status === Status.PLAY) {
                audio.pause();
                this.setState({ status: Status.STOP });
            }
            else {
                audio.currentTime = 0;
                audio.play();
                this.setState({ status: Status.PLAY });
            }
            if (onClick)
                onClick();
        };
    }
    componentDidMount() {
        setTimeout(_ => {
            this.audio.addEventListener('ended', () => {
                this.setState({ status: Status.STOP });
            });
        }, 0);
    }
    render() {
        const { url, isPad, className, duration } = this.props;
        return (React.createElement("div", { className: classnames('ph-audio-block', className, {
                'on-play': this.state.status === Status.PLAY,
                'is-pad': isPad,
            }), onClick: this.clickHandler },
            React.createElement("div", { className: "animation-container" },
                React.createElement("i", { className: "animation-item" }),
                React.createElement("i", { className: "animation-item" }),
                React.createElement("i", { className: "animation-item" }),
                React.createElement("i", { className: "animation-item" })),
            React.createElement("span", { className: "duration-text" }, duration !== undefined && `${duration}''`),
            React.createElement("audio", { className: "audio-el", ref: el => (this.audio = el), src: url })));
    }
}

export default AudioBlock;
