import classnames from 'classnames';
import { createElement } from 'react';

function styleInject(css, ref) {
  if ( ref === void 0 ) ref = {};
  var insertAt = ref.insertAt;

  if (!css || typeof document === 'undefined') { return; }

  var head = document.head || document.getElementsByTagName('head')[0];
  var style = document.createElement('style');
  style.type = 'text/css';

  if (insertAt === 'top') {
    if (head.firstChild) {
      head.insertBefore(style, head.firstChild);
    } else {
      head.appendChild(style);
    }
  } else {
    head.appendChild(style);
  }

  if (style.styleSheet) {
    style.styleSheet.cssText = css;
  } else {
    style.appendChild(document.createTextNode(css));
  }
}

var css = ".ph-avatar {\n  position: relative;\n  display: inline-block;\n  width: 1.06667rem;\n  height: 1.06667rem;\n  text-align: center;\n  background-color: #fff;\n  border-radius: 50%;\n}\n.ph-avatar.is-pad {\n  width: 0.50781rem;\n  height: 0.50781rem;\n}\n.ph-avatar img {\n  position: absolute;\n  top: 50%;\n  left: 50%;\n  width: 70%;\n  height: 70%;\n  -webkit-transform: translate(-50%, -50%);\n          transform: translate(-50%, -50%);\n}\n";
styleInject(css);

const AVATAR_MAP = {
    male: 'https://cdn.llscdn.com/sprout/sprout-hybrid/avatar/imgBoy@3x.png',
    female: 'https://cdn.llscdn.com/sprout/sprout-hybrid/avatar/imgGirl@3x.png'
};
const DEFAULT_AVATAR = AVATAR_MAP.male;
var genderList;
(function (genderList) {
    genderList["male"] = "male";
    genderList["female"] = "female";
})(genderList || (genderList = {}));
Avatar.AVATAR_MAP = AVATAR_MAP;
function Avatar(props) {
    const { className, url, gender, isPad } = props;
    const avatar = url || ((gender && AVATAR_MAP[gender]) || DEFAULT_AVATAR);
    return (createElement("div", { className: classnames('ph-avatar', className, {
            'is-pad': isPad
        }) },
        createElement("img", { src: avatar, alt: "avatar" })));
}

export default Avatar;
export { genderList };
