import classnames from 'classnames';
import React, { Component } from 'react';

function styleInject(css, ref) {
  if ( ref === void 0 ) ref = {};
  var insertAt = ref.insertAt;

  if (!css || typeof document === 'undefined') { return; }

  var head = document.head || document.getElementsByTagName('head')[0];
  var style = document.createElement('style');
  style.type = 'text/css';

  if (insertAt === 'top') {
    if (head.firstChild) {
      head.insertBefore(style, head.firstChild);
    } else {
      head.appendChild(style);
    }
  } else {
    head.appendChild(style);
  }

  if (style.styleSheet) {
    style.styleSheet.cssText = css;
  } else {
    style.appendChild(document.createTextNode(css));
  }
}

var css = ".ph-checkbox {\n  position: relative;\n  display: -webkit-box;\n  display: flex;\n  -webkit-box-align: center;\n          align-items: center;\n  -webkit-box-pack: start;\n          justify-content: flex-start;\n}\n.ph-checkbox .ph-checkbox-img {\n  width: 0.64rem;\n  height: 0.64rem;\n}\n.ph-checkbox .ph-checkbox-img {\n  background: url(\"data:image/svg+xml,%3C%3Fxml version%3D%221.0%22 encoding%3D%22UTF-8%22%3F%3E%3Csvg width%3D%2224px%22 height%3D%2224px%22 viewBox%3D%220 0 24 24%22 version%3D%221.1%22 xmlns%3D%22http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg%22 xmlns%3Axlink%3D%22http%3A%2F%2Fwww.w3.org%2F1999%2Fxlink%22%3E    %3C!-- Generator%3A Sketch 53.2 (72643) - https%3A%2F%2Fsketchapp.com --%3E    %3Ctitle%3EIcon%2FOtherIcon%2FCheckBoxSelected%3C%2Ftitle%3E    %3Cdesc%3ECreated with Sketch.%3C%2Fdesc%3E    %3Cg id%3D%22%E9%A1%B5%E9%9D%A2-1%22 stroke%3D%22none%22 stroke-width%3D%221%22 fill%3D%22none%22 fill-rule%3D%22evenodd%22%3E        %3Cg id%3D%22b.4-%E5%85%91%E6%8D%A2%E8%AF%BE%E7%A8%8B%22 transform%3D%22translate(-96.000000%2C -368.000000)%22 fill%3D%22%23FFFFFF%22 stroke%3D%22%23FFB400%22%3E            %3Cg id%3D%22Icon%2FOtherIcon%2FCheckBoxUnselected%22 transform%3D%22translate(96.000000%2C 368.000000)%22%3E                %3Cg id%3D%22Phone%2FIcon%2FOtherIcon%2FCheckBoxUnselected%22%3E                    %3Cg id%3D%22checkbox_checked_s%22 stroke-width%3D%223%22%3E                        %3Crect id%3D%22Rectangle-2%22 x%3D%221.5%22 y%3D%221.5%22 width%3D%2221%22 height%3D%2221%22 rx%3D%226.85714286%22%3E%3C%2Frect%3E                    %3C%2Fg%3E                %3C%2Fg%3E            %3C%2Fg%3E        %3C%2Fg%3E    %3C%2Fg%3E%3C%2Fsvg%3E\") no-repeat;\n  touch-action: none;\n  background-size: contain;\n}\n.ph-checkbox .ph-checkbox-checked {\n  background: url(\"data:image/svg+xml,%3C%3Fxml version%3D%221.0%22 encoding%3D%22UTF-8%22%3F%3E%3Csvg width%3D%2224px%22 height%3D%2224px%22 viewBox%3D%220 0 24 24%22 version%3D%221.1%22 xmlns%3D%22http%3A%2F%2Fwww.w3.org%2F2000%2Fsvg%22 xmlns%3Axlink%3D%22http%3A%2F%2Fwww.w3.org%2F1999%2Fxlink%22%3E    %3C!-- Generator%3A Sketch 53.2 (72643) - https%3A%2F%2Fsketchapp.com --%3E    %3Ctitle%3EIcon%2FOtherIcon%2FCheckBoxSelected%3C%2Ftitle%3E    %3Cdesc%3ECreated with Sketch.%3C%2Fdesc%3E    %3Cg id%3D%22%E9%A1%B5%E9%9D%A2-1%22 stroke%3D%22none%22 stroke-width%3D%221%22 fill%3D%22none%22 fill-rule%3D%22evenodd%22%3E        %3Cg id%3D%22b.4-%E5%85%91%E6%8D%A2%E8%AF%BE%E7%A8%8B-%E8%BE%93%E5%85%A5%E7%8A%B6%E6%80%81%22 transform%3D%22translate(-96.000000%2C -368.000000)%22 stroke%3D%22%23FFB400%22%3E            %3Cg id%3D%22Icon%2FOtherIcon%2FCheckBoxSelected%22 transform%3D%22translate(96.000000%2C 368.000000)%22%3E                %3Cg id%3D%22Phone%2FIcon%2FOtherIcon%2FCheckBoxSelected%22%3E                    %3Cg id%3D%22App%2FBTN%2FPhoneBTN%2Fsignup%2FcheekBox%2FSelected%22 stroke-width%3D%223%22%3E                        %3Crect id%3D%22Rectangle-2%22 fill%3D%22%23FFFFFF%22 x%3D%221.5%22 y%3D%221.5%22 width%3D%2221%22 height%3D%2221%22 rx%3D%226.85714286%22%3E%3C%2Frect%3E                        %3Cpolyline id%3D%22%E8%B7%AF%E5%BE%84%22 stroke-linecap%3D%22round%22 stroke-linejoin%3D%22round%22 points%3D%227 12.2091324 11.4428424 15.587039 17.3983276 8.99038021%22%3E%3C%2Fpolyline%3E                    %3C%2Fg%3E                %3C%2Fg%3E            %3C%2Fg%3E        %3C%2Fg%3E    %3C%2Fg%3E%3C%2Fsvg%3E\") no-repeat;\n  background-size: contain;\n}\n.ph-checkbox .ph-checkbox-label {\n  padding-left: 0.21333rem;\n  -webkit-box-flex: 1;\n          flex: 1;\n  font-size: 0.42667rem;\n}\n.ph-checkbox-pad .ph-checkbox-img {\n  position: absolute;\n  width: 0.23438rem;\n  height: 0.23438rem;\n}\n.ph-checkbox-pad .ph-checkbox-label {\n  padding-left: 0.07813rem;\n  font-size: 0.15625rem;\n}\n";
styleInject(css);

class CheckBox extends Component {
    constructor() {
        super(...arguments);
        this.onChange = () => {
            const { value, onChange } = this.props;
            // tslint:disable-next-line
            onChange && onChange(!value);
        };
    }
    render() {
        const { isPad, label, children, className, value } = this.props;
        const { onChange } = this;
        return (React.createElement("div", { className: classnames('ph-checkbox', className, {
                'ph-checkbox-pad': isPad
            }), onClick: onChange },
            React.createElement("div", { className: classnames('ph-checkbox-img', {
                    'ph-checkbox-checked': value
                }) }),
            React.createElement("div", { className: "ph-checkbox-label" }, children ? children : label)));
    }
}
CheckBox.defaultProps = {
    className: ''
};

export default CheckBox;
