import classnames from 'classnames';
import React, { Component } from 'react';
import ReactDOM from 'react-dom';

var context = React.createContext({});

class Confirm extends Component {
    render() {
        return (React.createElement(context.Consumer, null, ({ cancelText, confirmText, onConfirmClick, onCancelClick, content, children }) => (React.createElement("div", { className: "ph-dialog-confirm" },
            React.createElement("div", { className: "ph-dialog-content" }, children ? children : content),
            React.createElement("div", { className: "ph-dialog-btn-area" },
                React.createElement("div", { className: "ph-dialog-btn ph-dialog-cancelbtn", onClick: onCancelClick }, cancelText),
                React.createElement("div", { className: "ph-dialog-btn ph-dialog-confirmbtn", onClick: onConfirmClick }, confirmText))))));
    }
}
Confirm.defaultProps = {
    onConfirmClick: () => { },
    onCancelClick: () => { },
    cancelText: '取消',
    confirmText: '确定',
    content: ''
};

function styleInject(css, ref) {
  if ( ref === void 0 ) ref = {};
  var insertAt = ref.insertAt;

  if (!css || typeof document === 'undefined') { return; }

  var head = document.head || document.getElementsByTagName('head')[0];
  var style = document.createElement('style');
  style.type = 'text/css';

  if (insertAt === 'top') {
    if (head.firstChild) {
      head.insertBefore(style, head.firstChild);
    } else {
      head.appendChild(style);
    }
  } else {
    head.appendChild(style);
  }

  if (style.styleSheet) {
    style.styleSheet.cssText = css;
  } else {
    style.appendChild(document.createTextNode(css));
  }
}

var css = ".ph-dialog-wrapper {\n  position: fixed;\n  top: 0;\n  right: 0;\n  bottom: 0;\n  left: 0;\n  background: rgba(0, 0, 0, 0.6);\n  display: -webkit-box;\n  display: flex;\n  -webkit-box-pack: center;\n          justify-content: center;\n  -webkit-box-align: center;\n          align-items: center;\n  z-index: 9999;\n}\n.ph-dialog {\n  width: 8.21333rem;\n  min-height: 4.96rem;\n  border-radius: 0.64rem;\n  background: #fff;\n  display: -webkit-box;\n  display: flex;\n  -webkit-box-orient: vertical;\n  -webkit-box-direction: normal;\n          flex-direction: column;\n}\n.ph-dialog-confirm {\n  display: -webkit-box;\n  display: flex;\n  -webkit-box-orient: vertical;\n  -webkit-box-direction: normal;\n          flex-direction: column;\n  -webkit-box-pack: justify;\n          justify-content: space-between;\n  -webkit-box-flex: 1;\n          flex: 1;\n}\n.ph-dialog-confirm .ph-dialog-content {\n  padding: 0.53333rem 0.85333rem;\n  color: #202b43;\n  font-size: 0.48rem;\n  line-height: 0.64rem;\n  word-break: break-all;\n  display: -webkit-box;\n  display: flex;\n  -webkit-box-align: center;\n          align-items: center;\n  -webkit-box-flex: 1;\n          flex: 1;\n}\n.ph-dialog-confirm .ph-dialog-btn-area {\n  display: -webkit-box;\n  display: flex;\n  -webkit-box-pack: justify;\n          justify-content: space-between;\n  padding: 0 0.42667rem 0.37333rem;\n}\n.ph-dialog-confirm .ph-dialog-btn {\n  width: 3.41333rem;\n  height: 1.44rem;\n  text-align: center;\n  line-height: 1.44rem;\n  font-size: 0.53333rem;\n  border-radius: 0.74667rem;\n}\n.ph-dialog-confirm .ph-dialog-cancelbtn {\n  background: #f4f6f8;\n  color: #788295;\n}\n.ph-dialog-confirm .ph-dialog-confirmbtn {\n  background: #ffb400;\n  color: #fff;\n}\n.ph-dialog-pad {\n  width: 3.00781rem;\n  min-height: 1.81641rem;\n  border-radius: 0.23438rem;\n}\n.ph-dialog-pad .ph-dialog-confirm .ph-dialog-content {\n  padding: 0.19531rem 0.3125rem;\n  font-size: 0.17578rem;\n  line-height: 0.23438rem;\n}\n.ph-dialog-pad .ph-dialog-confirm .ph-dialog-btn-area {\n  padding: 0 0.15625rem 0.13672rem;\n}\n.ph-dialog-pad .ph-dialog-confirm .ph-dialog-btn {\n  width: 1.25rem;\n  height: 0.52734rem;\n  text-align: center;\n  line-height: 0.52734rem;\n  font-size: 0.19531rem;\n  border-radius: 0.27344rem;\n}\n";
styleInject(css);

function getChild(type) {
    switch (type) {
        case 'confirm':
            return Confirm;
        default:
            return React.createElement("div", null);
    }
}
let _instace = 0;
class Dialog extends Component {
    constructor(props) {
        super(props);
        this.istance = _instace++;
        this.onWrapperClick = () => {
            if (this.props.hideOnClickWrapper) {
                this.setState({ show: false }, () => {
                    this.props.onChange(this.state.show);
                });
                this.props.onCancelClick();
            }
        };
        this.state = { show: this.props.visible };
        const div = document.createElement('div');
        div.id = `ph-dialog-instance-${this.istance}`;
        document.body.appendChild(div);
        this.domNode = div;
    }
    componentWillReceiveProps(nextProps) {
        this.setState({
            show: nextProps.visible
        });
    }
    render() {
        const { isPad, type, cancelText, confirmText, onConfirmClick, onCancelClick, content, children } = this.props;
        const { show } = this.state;
        const { onWrapperClick } = this;
        const Child = getChild(type);
        return ReactDOM.createPortal(React.createElement(context.Provider, { value: {
                cancelText,
                confirmText,
                onConfirmClick,
                onCancelClick,
                content,
                children
            } },
            React.createElement("div", { className: "ph-dialog-wrapper", style: {
                    display: show ? 'flex' : 'none'
                }, onClick: onWrapperClick },
                React.createElement("div", { onClick: e => e.stopPropagation(), className: classnames('ph-dialog', {
                        'ph-dialog-pad': isPad
                    }) },
                    React.createElement(Child, null)))), this.domNode);
    }
}
Dialog.defaultProps = {
    type: 'confirm',
    hideOnClickWrapper: true,
    onChange: () => { },
    onConfirmClick: () => { },
    onCancelClick: () => { },
    cancelText: '取消',
    confirmText: '确定',
    content: ''
};

export default Dialog;
