import React, { PureComponent } from 'react';
import { LONG_TOUCH_DURATION, MAX_MOVE } from '../common';

class LongTouch extends PureComponent {
    constructor() {
        super(...arguments);
        this.touchTimer = null;
        this.touchX = 0;
        this.touchY = 0;
        this.onTouchStart = (e) => {
            const { pageX, pageY } = e.touches[0];
            this.touchX = pageX;
            this.touchY = pageY;
            this.touchTimer = Date.now();
        };
        this.onTouchEnd = (e) => {
            const touchDuration = Date.now() - this.touchTimer;
            const { pageX, pageY } = e.changedTouches[0];
            const { onLongTouch } = this.props;
            const { touchX, touchY } = this;
            const isMove = pageX - touchX > MAX_MOVE ||
                touchX - pageX > MAX_MOVE ||
                pageY - touchY > MAX_MOVE ||
                touchY - pageY > MAX_MOVE;
            if (touchDuration > LONG_TOUCH_DURATION && onLongTouch && !isMove) {
                onLongTouch();
            }
        };
    }
    render() {
        return (React.createElement("div", { onTouchStart: this.onTouchStart, onTouchEnd: this.onTouchEnd, onTouchCancel: this.onTouchEnd }, this.props.children));
    }
}

export default LongTouch;
