import classnames from 'classnames';
import React from 'react';
import { PHONE_RATIO, PAD_RATIO } from '../common';
import Imager from '../imager';

function styleInject(css, ref) {
  if ( ref === void 0 ) ref = {};
  var insertAt = ref.insertAt;

  if (!css || typeof document === 'undefined') { return; }

  var head = document.head || document.getElementsByTagName('head')[0];
  var style = document.createElement('style');
  style.type = 'text/css';

  if (insertAt === 'top') {
    if (head.firstChild) {
      head.insertBefore(style, head.firstChild);
    } else {
      head.appendChild(style);
    }
  } else {
    head.appendChild(style);
  }

  if (style.styleSheet) {
    style.styleSheet.cssText = css;
  } else {
    style.appendChild(document.createTextNode(css));
  }
}

var css = ".ph-page-fail {\n  text-align: center;\n  padding-top: 2.98667rem;\n  padding-bottom: 0.53333rem;\n}\n.ph-page-fail.is-pad {\n  padding-top: 1.42578rem;\n  padding-bottom: 0.19531rem;\n}\n.ph-page-fail.is-pad .fail-image {\n  width: 2.03125rem;\n  margin: 0 auto;\n}\n.ph-page-fail.is-pad .fail-text {\n  margin-top: 0.19531rem;\n  font-size: 0.23438rem;\n  line-height: 0.29297rem;\n}\n.ph-page-fail.is-pad .reload-btn {\n  height: 0.64453rem;\n  font-size: 0.27344rem;\n  line-height: 0.64453rem;\n  border-radius: 0.32227rem;\n  margin: 1.73828rem auto 0;\n  width: 80%;\n}\n.ph-page-fail .fail-image {\n  width: 5.54667rem;\n  margin: 0 auto;\n}\n.ph-page-fail .fail-text {\n  margin-top: 0.26667rem;\n  color: #b5b7bd;\n  font-size: 0.42667rem;\n  line-height: 0.8rem;\n}\n.ph-page-fail .reload-btn {\n  display: block;\n  overflow: hidden;\n  height: 1.49333rem;\n  color: #fff;\n  font-size: 0.53333rem;\n  font-weight: 400;\n  line-height: 1.49333rem;\n  text-align: center;\n  text-overflow: ellipsis;\n  word-break: break-word;\n  white-space: nowrap;\n  background-color: #ffbb0a;\n  border-radius: 0.74667rem;\n  border: none;\n  padding: 0 2rem;\n  margin: 0.37333rem auto 0;\n  outline: 0;\n  touch-action: manipulation;\n}\n";
styleInject(css);

const PHONE_IMAGE = [
    {
        375: 'https://cdn.llscdn.com/phonics-ui/phone-empty.png',
        750: 'https://cdn.llscdn.com/phonics-ui/phone-empty@2x.png',
        1125: 'https://cdn.llscdn.com/phonics-ui/phone-empty@3x.png',
        height: `${168 / PHONE_RATIO}rem`
    }
];
const PAD_IMAGE = [
    {
        1024: 'https://cdn.llscdn.com/phonics-ui/phone-empty@3x.png',
        2048: 'https://cdn.llscdn.com/phonics-ui/phone-empty@3x.png',
        3072: 'https://cdn.llscdn.com/phonics-ui/phone-empty@3x.png',
        height: `${168 / PAD_RATIO}rem`
    }
];
function reload() {
    window.location.reload();
}
function PageFail(props) {
    const { isPad, className } = props;
    return (React.createElement("div", { className: classnames('ph-page-fail', className, { 'is-pad': isPad }) },
        React.createElement(Imager, { className: "fail-image", isPad: isPad, imgList: isPad ? PAD_IMAGE : PHONE_IMAGE }),
        React.createElement("p", { className: "fail-text" }, "\u52A0\u8F7D\u5931\u8D25"),
        React.createElement("button", { className: "reload-btn", onClick: reload }, "\u91CD\u65B0\u52A0\u8F7D")));
}

export default PageFail;
