import '@lls/lls-ui/es/Toast/style.css';
import Toast from '@lls/lls-ui/es/Toast';
import { getIsPadDisplay } from '../utils';

function styleInject(css, ref) {
  if ( ref === void 0 ) ref = {};
  var insertAt = ref.insertAt;

  if (!css || typeof document === 'undefined') { return; }

  var head = document.head || document.getElementsByTagName('head')[0];
  var style = document.createElement('style');
  style.type = 'text/css';

  if (insertAt === 'top') {
    if (head.firstChild) {
      head.insertBefore(style, head.firstChild);
    } else {
      head.appendChild(style);
    }
  } else {
    head.appendChild(style);
  }

  if (style.styleSheet) {
    style.styleSheet.cssText = css;
  } else {
    style.appendChild(document.createTextNode(css));
  }
}

var css = ".ph-pad-body.ph-pad-body .lls-ui-toast-content {\n  padding: 0.09766rem;\n  font-size: 0.15625rem;\n  border-radius: 0.05859rem;\n}\n.lls-ui-toast.lls-ui-toast p {\n  text-overflow: unset;\n  white-space: normal;\n}\n";
styleInject(css);

if (getIsPadDisplay()) {
    setTimeout(() => {
        document.body.classList.add('ph-pad-body');
    }, 0);
}

export default Toast;
