import FontFaceObserver from 'fontfaceobserver';

const getType = (v) => Object.prototype.toString.call(v);
const isFunction = (v) => getType(v) === '[object Function]';
const isObject = (v) => getType(v) === '[object Object]';
const getIsPadDisplay = () => window.innerWidth >= 1024 && window.innerWidth > window.innerHeight;
const noop = () => { };
function loadPrimaryFont(el = document.body) {
    const FONT_LOAD_MAX_TIME = 30000;
    const FONT_NAME = 'FZY4JW';
    const font = new FontFaceObserver(FONT_NAME);
    font.load(null, FONT_LOAD_MAX_TIME).then(() => {
        el.style.fontFamily = FONT_NAME;
    }, noop);
}
const toArray = (target) => Array.prototype.slice.call(target);
const preloadImage = (imgList) => Promise.all(imgList.map(loadImage));
const loadImage = (imgSrc) => new Promise((resolve, reject) => {
    const img = new Image();
    img.src = imgSrc;
    img.onload = () => {
        resolve();
    };
    img.onerror = () => {
        reject();
    };
});

export { getIsPadDisplay, getType, isFunction, isObject, loadImage, loadPrimaryFont, noop, preloadImage, toArray };
