import classnames from 'classnames';
import React from 'react';

function _classCallCheck(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
}

function _defineProperties(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || false;
    descriptor.configurable = true;
    if ("value" in descriptor) descriptor.writable = true;
    Object.defineProperty(target, descriptor.key, descriptor);
  }
}

function _createClass(Constructor, protoProps, staticProps) {
  if (protoProps) _defineProperties(Constructor.prototype, protoProps);
  if (staticProps) _defineProperties(Constructor, staticProps);
  return Constructor;
}

function _inherits(subClass, superClass) {
  if (typeof superClass !== "function" && superClass !== null) {
    throw new TypeError("Super expression must either be null or a function");
  }

  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      writable: true,
      configurable: true
    }
  });
  if (superClass) _setPrototypeOf(subClass, superClass);
}

function _getPrototypeOf(o) {
  _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
    return o.__proto__ || Object.getPrototypeOf(o);
  };
  return _getPrototypeOf(o);
}

function _setPrototypeOf(o, p) {
  _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
    o.__proto__ = p;
    return o;
  };

  return _setPrototypeOf(o, p);
}

function _assertThisInitialized(self) {
  if (self === void 0) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }

  return self;
}

function _possibleConstructorReturn(self, call) {
  if (call && (typeof call === "object" || typeof call === "function")) {
    return call;
  }

  return _assertThisInitialized(self);
}

var Status;

(function (Status) {
  Status[Status["PLAY"] = 0] = "PLAY";
  Status[Status["STOP"] = 1] = "STOP";
})(Status || (Status = {}));

var AudioBlock =
/*#__PURE__*/
function (_React$Component) {
  _inherits(AudioBlock, _React$Component);

  function AudioBlock() {
    var _this;

    _classCallCheck(this, AudioBlock);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(AudioBlock).apply(this, arguments));
    _this.audio = null;
    _this.state = {
      status: Status.STOP
    };

    _this.clickHandler = function () {
      var status = _this.state.status;
      var onClick = _this.props.onClick;
      var audio = _this.audio;

      if (status === Status.PLAY) {
        audio.pause();

        _this.setState({
          status: Status.STOP
        });
      } else {
        audio.currentTime = 0;
        audio.play();

        _this.setState({
          status: Status.PLAY
        });
      }

      if (onClick) onClick();
    };

    return _this;
  }

  _createClass(AudioBlock, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this2 = this;

      setTimeout(function (_) {

        _this2.audio.addEventListener('ended', function () {
          _this2.setState({
            status: Status.STOP
          });
        });
      }, 0);
    }
  }, {
    key: "render",
    value: function render() {
      var _this3 = this;

      var _this$props = this.props,
          url = _this$props.url,
          isPad = _this$props.isPad,
          className = _this$props.className,
          duration = _this$props.duration;
      return React.createElement("div", {
        className: classnames('ph-audio-block', className, {
          'on-play': this.state.status === Status.PLAY,
          'is-pad': isPad
        }),
        onClick: this.clickHandler
      }, React.createElement("div", {
        className: "animation-container"
      }, React.createElement("i", {
        className: "animation-item"
      }), React.createElement("i", {
        className: "animation-item"
      }), React.createElement("i", {
        className: "animation-item"
      }), React.createElement("i", {
        className: "animation-item"
      })), React.createElement("span", {
        className: "duration-text"
      }, duration !== undefined && "".concat(duration, "''")), React.createElement("audio", {
        className: "audio-el",
        ref: function ref(el) {
          return _this3.audio = el;
        },
        src: url
      }));
    }
  }]);

  return AudioBlock;
}(React.Component);

export default AudioBlock;
