import classnames from 'classnames';
import { createElement } from 'react';

var AVATAR_MAP = {
  male: 'https://cdn.llscdn.com/sprout/sprout-hybrid/avatar/imgBoy@3x.png',
  female: 'https://cdn.llscdn.com/sprout/sprout-hybrid/avatar/imgGirl@3x.png'
};
var DEFAULT_AVATAR = AVATAR_MAP.male;
var genderList;

(function (genderList) {
  genderList["male"] = "male";
  genderList["female"] = "female";
})(genderList || (genderList = {}));

Avatar.AVATAR_MAP = AVATAR_MAP;
function Avatar(props) {
  var className = props.className,
      url = props.url,
      gender = props.gender,
      isPad = props.isPad;
  var avatar = url || gender && AVATAR_MAP[gender] || DEFAULT_AVATAR;
  return createElement("div", {
    className: classnames('ph-avatar', className, {
      'is-pad': isPad
    })
  }, createElement("img", {
    src: avatar,
    alt: "avatar"
  }));
}

export default Avatar;
export { genderList };
