import classnames from 'classnames';
import React, { Component } from 'react';

function _classCallCheck(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
}

function _defineProperties(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || false;
    descriptor.configurable = true;
    if ("value" in descriptor) descriptor.writable = true;
    Object.defineProperty(target, descriptor.key, descriptor);
  }
}

function _createClass(Constructor, protoProps, staticProps) {
  if (protoProps) _defineProperties(Constructor.prototype, protoProps);
  if (staticProps) _defineProperties(Constructor, staticProps);
  return Constructor;
}

function _inherits(subClass, superClass) {
  if (typeof superClass !== "function" && superClass !== null) {
    throw new TypeError("Super expression must either be null or a function");
  }

  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      writable: true,
      configurable: true
    }
  });
  if (superClass) _setPrototypeOf(subClass, superClass);
}

function _getPrototypeOf(o) {
  _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
    return o.__proto__ || Object.getPrototypeOf(o);
  };
  return _getPrototypeOf(o);
}

function _setPrototypeOf(o, p) {
  _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
    o.__proto__ = p;
    return o;
  };

  return _setPrototypeOf(o, p);
}

function _assertThisInitialized(self) {
  if (self === void 0) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }

  return self;
}

function _possibleConstructorReturn(self, call) {
  if (call && (typeof call === "object" || typeof call === "function")) {
    return call;
  }

  return _assertThisInitialized(self);
}

var CheckBox =
/*#__PURE__*/
function (_Component) {
  _inherits(CheckBox, _Component);

  function CheckBox() {
    var _this;

    _classCallCheck(this, CheckBox);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(CheckBox).apply(this, arguments));

    _this.onChange = function () {
      var _this$props = _this.props,
          value = _this$props.value,
          onChange = _this$props.onChange; // tslint:disable-next-line

      onChange && onChange(!value);
    };

    return _this;
  }

  _createClass(CheckBox, [{
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
          isPad = _this$props2.isPad,
          label = _this$props2.label,
          children = _this$props2.children,
          className = _this$props2.className,
          value = _this$props2.value;
      var onChange = this.onChange;
      return React.createElement("div", {
        className: classnames('ph-checkbox', className, {
          'ph-checkbox-pad': isPad
        }),
        onClick: onChange
      }, React.createElement("div", {
        className: classnames('ph-checkbox-img', {
          'ph-checkbox-checked': value
        })
      }), React.createElement("div", {
        className: "ph-checkbox-label"
      }, children ? children : label));
    }
  }]);

  return CheckBox;
}(Component);

CheckBox.defaultProps = {
  className: ''
};

export default CheckBox;
