import classnames from 'classnames';
import React, { PureComponent } from 'react';

function _classCallCheck(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
}

function _defineProperties(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || false;
    descriptor.configurable = true;
    if ("value" in descriptor) descriptor.writable = true;
    Object.defineProperty(target, descriptor.key, descriptor);
  }
}

function _createClass(Constructor, protoProps, staticProps) {
  if (protoProps) _defineProperties(Constructor.prototype, protoProps);
  if (staticProps) _defineProperties(Constructor, staticProps);
  return Constructor;
}

function _inherits(subClass, superClass) {
  if (typeof superClass !== "function" && superClass !== null) {
    throw new TypeError("Super expression must either be null or a function");
  }

  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      writable: true,
      configurable: true
    }
  });
  if (superClass) _setPrototypeOf(subClass, superClass);
}

function _getPrototypeOf(o) {
  _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
    return o.__proto__ || Object.getPrototypeOf(o);
  };
  return _getPrototypeOf(o);
}

function _setPrototypeOf(o, p) {
  _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
    o.__proto__ = p;
    return o;
  };

  return _setPrototypeOf(o, p);
}

function _assertThisInitialized(self) {
  if (self === void 0) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }

  return self;
}

function _possibleConstructorReturn(self, call) {
  if (call && (typeof call === "object" || typeof call === "function")) {
    return call;
  }

  return _assertThisInitialized(self);
}

var ClickAnime =
/*#__PURE__*/
function (_PureComponent) {
  _inherits(ClickAnime, _PureComponent);

  function ClickAnime() {
    var _this;

    _classCallCheck(this, ClickAnime);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(ClickAnime).apply(this, arguments));
    _this.el = null;
    _this.state = {
      touchIn: false
    };

    _this.touchStart = function () {
      _this.setState({
        touchIn: true
      });
    };

    _this.touchEnd = function () {
      _this.setState({
        touchIn: false
      });
    };

    return _this;
  }

  _createClass(ClickAnime, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      var _this$props = this.props,
          children = _this$props.children,
          className = _this$props.className,
          startTransform = _this$props.startTransform,
          endTransform = _this$props.endTransform,
          selected = _this$props.selected,
          _onClick = _this$props.onClick;
      return React.createElement("div", {
        className: classnames('ph-click-anime', className),
        style: {
          transform: this.state.touchIn || selected ? endTransform : startTransform
        },
        onClick: function onClick(e) {
          if (_onClick) _onClick(e);
        },
        ref: function ref(el) {
          return _this2.el = el;
        },
        onTouchStart: this.touchStart,
        onTouchEnd: this.touchEnd,
        onTouchCancel: this.touchEnd
      }, children);
    }
  }]);

  return ClickAnime;
}(PureComponent);
ClickAnime.defaultProps = {
  startTransform: 'scale(1)',
  endTransform: 'scale(1.08)',
  selected: false
};

export default ClickAnime;
