import classnames from 'classnames';
import React, { Component } from 'react';
import ReactDOM from 'react-dom';

function _classCallCheck(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
}

function _defineProperties(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || false;
    descriptor.configurable = true;
    if ("value" in descriptor) descriptor.writable = true;
    Object.defineProperty(target, descriptor.key, descriptor);
  }
}

function _createClass(Constructor, protoProps, staticProps) {
  if (protoProps) _defineProperties(Constructor.prototype, protoProps);
  if (staticProps) _defineProperties(Constructor, staticProps);
  return Constructor;
}

function _inherits(subClass, superClass) {
  if (typeof superClass !== "function" && superClass !== null) {
    throw new TypeError("Super expression must either be null or a function");
  }

  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      writable: true,
      configurable: true
    }
  });
  if (superClass) _setPrototypeOf(subClass, superClass);
}

function _getPrototypeOf(o) {
  _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
    return o.__proto__ || Object.getPrototypeOf(o);
  };
  return _getPrototypeOf(o);
}

function _setPrototypeOf(o, p) {
  _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
    o.__proto__ = p;
    return o;
  };

  return _setPrototypeOf(o, p);
}

function _assertThisInitialized(self) {
  if (self === void 0) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }

  return self;
}

function _possibleConstructorReturn(self, call) {
  if (call && (typeof call === "object" || typeof call === "function")) {
    return call;
  }

  return _assertThisInitialized(self);
}

var context = React.createContext({});

var Confirm =
/*#__PURE__*/
function (_Component) {
  _inherits(Confirm, _Component);

  function Confirm() {
    _classCallCheck(this, Confirm);

    return _possibleConstructorReturn(this, _getPrototypeOf(Confirm).apply(this, arguments));
  }

  _createClass(Confirm, [{
    key: "render",
    value: function render() {
      return React.createElement(context.Consumer, null, function (_ref) {
        var cancelText = _ref.cancelText,
            confirmText = _ref.confirmText,
            onConfirmClick = _ref.onConfirmClick,
            onCancelClick = _ref.onCancelClick,
            content = _ref.content,
            children = _ref.children;
        return React.createElement("div", {
          className: "ph-dialog-confirm"
        }, React.createElement("div", {
          className: "ph-dialog-content"
        }, children ? children : content), React.createElement("div", {
          className: "ph-dialog-btn-area"
        }, React.createElement("div", {
          className: "ph-dialog-btn ph-dialog-cancelbtn",
          onClick: onCancelClick
        }, cancelText), React.createElement("div", {
          className: "ph-dialog-btn ph-dialog-confirmbtn",
          onClick: onConfirmClick
        }, confirmText)));
      });
    }
  }]);

  return Confirm;
}(Component);

Confirm.defaultProps = {
  onConfirmClick: function onConfirmClick() {},
  onCancelClick: function onCancelClick() {},
  cancelText: '取消',
  confirmText: '确定',
  content: ''
};

function getChild(type) {
  switch (type) {
    case 'confirm':
      return Confirm;

    default:
      return React.createElement("div", null);
  }
}

var _instace = 0;

var Dialog =
/*#__PURE__*/
function (_Component) {
  _inherits(Dialog, _Component);

  function Dialog(props) {
    var _this;

    _classCallCheck(this, Dialog);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(Dialog).call(this, props));
    _this.istance = _instace++;

    _this.onWrapperClick = function () {
      if (_this.props.hideOnClickWrapper) {
        _this.setState({
          show: false
        }, function () {
          _this.props.onChange(_this.state.show);
        });

        _this.props.onCancelClick();
      }
    };

    _this.state = {
      show: _this.props.visible
    };
    var div = document.createElement('div');
    div.id = "ph-dialog-instance-".concat(_this.istance);
    document.body.appendChild(div);
    _this.domNode = div;
    return _this;
  }

  _createClass(Dialog, [{
    key: "componentWillReceiveProps",
    value: function componentWillReceiveProps(nextProps) {
      this.setState({
        show: nextProps.visible
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
          isPad = _this$props.isPad,
          type = _this$props.type,
          cancelText = _this$props.cancelText,
          confirmText = _this$props.confirmText,
          onConfirmClick = _this$props.onConfirmClick,
          onCancelClick = _this$props.onCancelClick,
          content = _this$props.content,
          children = _this$props.children;
      var show = this.state.show;
      var onWrapperClick = this.onWrapperClick;
      var Child = getChild(type);
      return ReactDOM.createPortal(React.createElement(context.Provider, {
        value: {
          cancelText: cancelText,
          confirmText: confirmText,
          onConfirmClick: onConfirmClick,
          onCancelClick: onCancelClick,
          content: content,
          children: children
        }
      }, React.createElement("div", {
        className: "ph-dialog-wrapper",
        style: {
          display: show ? 'flex' : 'none'
        },
        onClick: onWrapperClick
      }, React.createElement("div", {
        onClick: function onClick(e) {
          return e.stopPropagation();
        },
        className: classnames('ph-dialog', {
          'ph-dialog-pad': isPad
        })
      }, React.createElement(Child, null)))), this.domNode);
    }
  }]);

  return Dialog;
}(Component);

Dialog.defaultProps = {
  type: 'confirm',
  hideOnClickWrapper: true,
  onChange: function onChange() {},
  onConfirmClick: function onConfirmClick() {},
  onCancelClick: function onCancelClick() {},
  cancelText: '取消',
  confirmText: '确定',
  content: ''
};

export default Dialog;
