import classnames from 'classnames';
import React__default, { createElement, Component } from 'react';

// tslint:disable-next-line
var PHONE_WIDTH_LIST = [375, 750, 1125]; // tslint:disable-next-line

var PAD_WIDTH_LIST = [1024, 2048, 3072];
var PHONE_RATIO = 37.5;
var PAD_RATIO = 102.4;
var LONG_TOUCH_DURATION = 700;
var MAX_MOVE = 5;

function _typeof(obj) {
  if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
    _typeof = function (obj) {
      return typeof obj;
    };
  } else {
    _typeof = function (obj) {
      return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
    };
  }

  return _typeof(obj);
}

function _classCallCheck(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
}

function _defineProperties(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || false;
    descriptor.configurable = true;
    if ("value" in descriptor) descriptor.writable = true;
    Object.defineProperty(target, descriptor.key, descriptor);
  }
}

function _createClass(Constructor, protoProps, staticProps) {
  if (protoProps) _defineProperties(Constructor.prototype, protoProps);
  if (staticProps) _defineProperties(Constructor, staticProps);
  return Constructor;
}

function _extends() {
  _extends = Object.assign || function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];

      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }

    return target;
  };

  return _extends.apply(this, arguments);
}

function _inherits(subClass, superClass) {
  if (typeof superClass !== "function" && superClass !== null) {
    throw new TypeError("Super expression must either be null or a function");
  }

  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      writable: true,
      configurable: true
    }
  });
  if (superClass) _setPrototypeOf(subClass, superClass);
}

function _getPrototypeOf(o) {
  _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
    return o.__proto__ || Object.getPrototypeOf(o);
  };
  return _getPrototypeOf(o);
}

function _setPrototypeOf(o, p) {
  _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
    o.__proto__ = p;
    return o;
  };

  return _setPrototypeOf(o, p);
}

function _assertThisInitialized(self) {
  if (self === void 0) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }

  return self;
}

function _possibleConstructorReturn(self, call) {
  if (call && (typeof call === "object" || typeof call === "function")) {
    return call;
  }

  return _assertThisInitialized(self);
}

function _slicedToArray(arr, i) {
  return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest();
}

function _arrayWithHoles(arr) {
  if (Array.isArray(arr)) return arr;
}

function _iterableToArrayLimit(arr, i) {
  var _arr = [];
  var _n = true;
  var _d = false;
  var _e = undefined;

  try {
    for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
      _arr.push(_s.value);

      if (i && _arr.length === i) break;
    }
  } catch (err) {
    _d = true;
    _e = err;
  } finally {
    try {
      if (!_n && _i["return"] != null) _i["return"]();
    } finally {
      if (_d) throw _e;
    }
  }

  return _arr;
}

function _nonIterableRest() {
  throw new TypeError("Invalid attempt to destructure non-iterable instance");
}

function getDPR() {
  var dpr = Math.floor(window.devicePixelRatio) || 1;
  if (dpr > 3) dpr = 3;
  if (dpr < 1) dpr = 1;
  return dpr;
}

var Imager =
/*#__PURE__*/
function (_React$Component) {
  _inherits(Imager, _React$Component);

  function Imager() {
    var _this;

    _classCallCheck(this, Imager);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(Imager).apply(this, arguments));
    _this.dpr = getDPR();
    _this.container = null;
    _this.touchTimer = null;
    _this.touchX = 0;
    _this.touchY = 0;

    _this.onTouchStart = function (e) {
      var _e$touches$ = e.touches[0],
          pageX = _e$touches$.pageX,
          pageY = _e$touches$.pageY;
      _this.touchX = pageX;
      _this.touchY = pageY;
      _this.touchTimer = Date.now();
    };

    _this.onTouchEnd = function (e) {
      var touchDuration = Date.now() - _this.touchTimer;

      var _e$changedTouches$ = e.changedTouches[0],
          pageX = _e$changedTouches$.pageX,
          pageY = _e$changedTouches$.pageY;
      var onLongTouch = _this.props.onLongTouch;

      var _assertThisInitialize = _assertThisInitialized(_this),
          touchX = _assertThisInitialize.touchX,
          touchY = _assertThisInitialize.touchY;

      var isMove = pageX - touchX > MAX_MOVE || touchX - pageX > MAX_MOVE || pageY - touchY > MAX_MOVE || touchY - pageY > MAX_MOVE;

      if (touchDuration > LONG_TOUCH_DURATION && onLongTouch && !isMove) {
        onLongTouch();
      }
    };

    return _this;
  }

  _createClass(Imager, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.initImage();
    }
  }, {
    key: "initImage",
    value: function initImage() {
      var _this2 = this;

      var _this$props = this.props,
          imgList = _this$props.imgList,
          onSuccess = _this$props.onSuccess,
          onFailure = _this$props.onFailure;
      var sequence = Promise.resolve();
      imgList.forEach(function (listItem, index) {
        sequence = sequence.then(function () {
          return _this2.createImage(listItem, index);
        });
      });
      sequence.then(onSuccess, onFailure);
    }
  }, {
    key: "createImage",
    value: function createImage(listItem, index) {
      var dpr = this.dpr,
          props = this.props,
          container = this.container;
      var widthList = props.widthList,
          onClick = props.onClick,
          useDivInner = props.useDivInner,
          isPad = props.isPad;
      var height = listItem.height,
          divInner = listItem.divInner;
      var isDivInner = typeof divInner === 'undefined' ? useDivInner : divInner;
      return new Promise(function (resolve, reject) {
        var box = document.createElement('div');
        box.className = 'imager-container';
        if (height) box.style.height = height;
        if (container) container.appendChild(box);
        var nodeType = isDivInner ? 'div' : 'img';
        var imgEl = document.createElement(nodeType);
        imgEl.className = 'imager-inner';

        if (onClick) {
          imgEl.addEventListener('click', function (event) {
            onClick(event, listItem, index);
          });
        }

        var list = widthList && widthList.length ? widthList : isPad ? PAD_WIDTH_LIST : PHONE_WIDTH_LIST;
        var resource = new Image();
        var miniImg = listItem[list[0]];
        var suitableImg = listItem[list[dpr - 1]];

        resource.onload = function () {
          box.style.backgroundImage = "url(".concat(miniImg, ")");
          box.style.backgroundSize = "100% 100%";

          if (isDivInner) {
            imgEl.style.backgroundImage = "url(".concat(suitableImg, ")");
          } else {
            var el = imgEl;
            el.src = suitableImg;
            el.style.height = height;
          }

          box.appendChild(imgEl);
          resolve();
        };

        resource.onerror = function (err) {
          reject(err);
        };

        resource.src = miniImg;
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this3 = this;

      var _this$props2 = this.props,
          className = _this$props2.className,
          isPad = _this$props2.isPad;
      return createElement("div", {
        onTouchStart: this.onTouchStart,
        onTouchEnd: this.onTouchEnd,
        onTouchCancel: this.onTouchEnd,
        ref: function ref(el) {
          return _this3.container = el;
        },
        className: classnames('ph-imager', className, {
          'is-pad': isPad
        })
      });
    }
  }]);

  return Imager;
}(Component);
Imager.defaultProps = {
  className: '',
  onSuccess: function onSuccess() {},
  onFailure: function onFailure() {}
};

var token = '%[a-f0-9]{2}';
var singleMatcher = new RegExp(token, 'gi');
var multiMatcher = new RegExp('(' + token + ')+', 'gi');

function decodeComponents(components, split) {
  try {
    // Try to decode the entire string first
    return decodeURIComponent(components.join(''));
  } catch (err) {// Do nothing
  }

  if (components.length === 1) {
    return components;
  }

  split = split || 1; // Split the array in 2 parts

  var left = components.slice(0, split);
  var right = components.slice(split);
  return Array.prototype.concat.call([], decodeComponents(left), decodeComponents(right));
}

function decode(input) {
  try {
    return decodeURIComponent(input);
  } catch (err) {
    var tokens = input.match(singleMatcher);

    for (var i = 1; i < tokens.length; i++) {
      input = decodeComponents(tokens, i).join('');
      tokens = input.match(singleMatcher);
    }

    return input;
  }
}

function customDecodeURIComponent(input) {
  // Keep track of all the replacements and prefill the map with the `BOM`
  var replaceMap = {
    '%FE%FF': "\uFFFD\uFFFD",
    '%FF%FE': "\uFFFD\uFFFD"
  };
  var match = multiMatcher.exec(input);

  while (match) {
    try {
      // Decode as big chunks as possible
      replaceMap[match[0]] = decodeURIComponent(match[0]);
    } catch (err) {
      var result = decode(match[0]);

      if (result !== match[0]) {
        replaceMap[match[0]] = result;
      }
    }

    match = multiMatcher.exec(input);
  } // Add `%C2` at the end of the map to make sure it does not replace the combinator before everything else


  replaceMap['%C2'] = "\uFFFD";
  var entries = Object.keys(replaceMap);

  for (var i = 0; i < entries.length; i++) {
    // Replace all decoded components
    var key = entries[i];
    input = input.replace(new RegExp(key, 'g'), replaceMap[key]);
  }

  return input;
}

var decodeUriComponent = function decodeUriComponent(encodedURI) {
  if (typeof encodedURI !== 'string') {
    throw new TypeError('Expected `encodedURI` to be of type `string`, got `' + _typeof(encodedURI) + '`');
  }

  try {
    encodedURI = encodedURI.replace(/\+/g, ' '); // Try the built in decoder first

    return decodeURIComponent(encodedURI);
  } catch (err) {
    // Fallback to a more advanced decoder
    return customDecodeURIComponent(encodedURI);
  }
};

var splitOnFirst = function splitOnFirst(string, separator) {
  if (!(typeof string === 'string' && typeof separator === 'string')) {
    throw new TypeError('Expected the arguments to be of type `string`');
  }

  if (separator === '') {
    return [string];
  }

  var separatorIndex = string.indexOf(separator);

  if (separatorIndex === -1) {
    return [string];
  }

  return [string.slice(0, separatorIndex), string.slice(separatorIndex + separator.length)];
};

function parserForArrayFormat(options) {
  var result;

  switch (options.arrayFormat) {
    case 'index':
      return function (key, value, accumulator) {
        result = /\[(\d*)\]$/.exec(key);
        key = key.replace(/\[\d*\]$/, '');

        if (!result) {
          accumulator[key] = value;
          return;
        }

        if (accumulator[key] === undefined) {
          accumulator[key] = {};
        }

        accumulator[key][result[1]] = value;
      };

    case 'bracket':
      return function (key, value, accumulator) {
        result = /(\[\])$/.exec(key);
        key = key.replace(/\[\]$/, '');

        if (!result) {
          accumulator[key] = value;
          return;
        }

        if (accumulator[key] === undefined) {
          accumulator[key] = [value];
          return;
        }

        accumulator[key] = [].concat(accumulator[key], value);
      };

    case 'comma':
      return function (key, value, accumulator) {
        var isArray = typeof value === 'string' && value.split('').indexOf(',') > -1;
        var newValue = isArray ? value.split(',') : value;
        accumulator[key] = newValue;
      };

    default:
      return function (key, value, accumulator) {
        if (accumulator[key] === undefined) {
          accumulator[key] = value;
          return;
        }

        accumulator[key] = [].concat(accumulator[key], value);
      };
  }
}

function decode$1(value, options) {
  if (options.decode) {
    return decodeUriComponent(value);
  }

  return value;
}

function keysSorter(input) {
  if (Array.isArray(input)) {
    return input.sort();
  }

  if (_typeof(input) === 'object') {
    return keysSorter(Object.keys(input)).sort(function (a, b) {
      return Number(a) - Number(b);
    }).map(function (key) {
      return input[key];
    });
  }

  return input;
}

function extract(input) {
  var queryStart = input.indexOf('?');

  if (queryStart === -1) {
    return '';
  }

  return input.slice(queryStart + 1);
}

function parse(input, options) {
  options = _extends({
    decode: true,
    arrayFormat: 'none'
  }, options);
  var formatter = parserForArrayFormat(options); // Create an object with no prototype

  var ret = Object.create(null);

  if (typeof input !== 'string') {
    return ret;
  }

  input = input.trim().replace(/^[?#&]/, '');

  if (!input) {
    return ret;
  }

  var _iteratorNormalCompletion = true;
  var _didIteratorError = false;
  var _iteratorError = undefined;

  try {
    for (var _iterator = input.split('&')[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
      var param = _step.value;

      var _splitOnFirst = splitOnFirst(param.replace(/\+/g, ' '), '='),
          _splitOnFirst2 = _slicedToArray(_splitOnFirst, 2),
          key = _splitOnFirst2[0],
          value = _splitOnFirst2[1]; // Missing `=` should be `null`:
      // http://w3.org/TR/2012/WD-url-20120524/#collect-url-parameters


      value = value === undefined ? null : decode$1(value, options);
      formatter(decode$1(key, options), value, ret);
    }
  } catch (err) {
    _didIteratorError = true;
    _iteratorError = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion && _iterator.return != null) {
        _iterator.return();
      }
    } finally {
      if (_didIteratorError) {
        throw _iteratorError;
      }
    }
  }

  return Object.keys(ret).sort().reduce(function (result, key) {
    var value = ret[key];

    if (Boolean(value) && _typeof(value) === 'object' && !Array.isArray(value)) {
      // Sort object keys, not values
      result[key] = keysSorter(value);
    } else {
      result[key] = value;
    }

    return result;
  }, Object.create(null));
}

var parseUrl = function parseUrl(input, options) {
  var hashStart = input.indexOf('#');

  if (hashStart !== -1) {
    input = input.slice(0, hashStart);
  }

  return {
    url: input.split('?')[0] || '',
    query: parse(extract(input), options)
  };
};

function parseParams() {
  var url = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : window.location.href;
  return parseUrl(url).query;
}

var PHONE_IMAGE = [{
  375: 'https://cdn.llscdn.com/phonics-ui/phone-empty.png',
  750: 'https://cdn.llscdn.com/phonics-ui/phone-empty@2x.png',
  1125: 'https://cdn.llscdn.com/phonics-ui/phone-empty@3x.png',
  height: "".concat(168 / PHONE_RATIO, "rem")
}];
var PAD_IMAGE = [{
  1024: 'https://cdn.llscdn.com/phonics-ui/pad-empty.png',
  2048: 'https://cdn.llscdn.com/phonics-ui/pad-empty@2x.png',
  3072: 'https://cdn.llscdn.com/phonics-ui/pad-empty@3x.png',
  height: "".concat(207 / PAD_RATIO, "rem")
}];
var DEFAULT_TEXT = '暂无数据';
function EmptyRecord(props) {
  var isPad = props.isPad,
      className = props.className,
      text = props.text;
  var emptyText = text || parseParams().text || DEFAULT_TEXT;
  return React__default.createElement("div", {
    className: classnames('ph-empty-record', className, {
      'is-pad': isPad
    })
  }, React__default.createElement(Imager, {
    className: "empty-image",
    isPad: isPad,
    imgList: isPad ? PAD_IMAGE : PHONE_IMAGE
  }), React__default.createElement("p", {
    className: "empty-text"
  }, emptyText));
}

export default EmptyRecord;
