import '@lls/lls-ui/es/Loading/style.css';
import classnames from 'classnames';
import { createElement } from 'react';
import ReactDOM from 'react-dom';
import Loading from '@lls/lls-ui/es/Loading';
import 'fontfaceobserver';

function _classCallCheck(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
}

function _defineProperties(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || false;
    descriptor.configurable = true;
    if ("value" in descriptor) descriptor.writable = true;
    Object.defineProperty(target, descriptor.key, descriptor);
  }
}

function _createClass(Constructor, protoProps, staticProps) {
  if (protoProps) _defineProperties(Constructor.prototype, protoProps);
  if (staticProps) _defineProperties(Constructor, staticProps);
  return Constructor;
}

var getIsPadDisplay = function getIsPadDisplay() {
  return window.innerWidth >= 1024 && window.innerWidth > window.innerHeight;
};

var LoadingComponent = function LoadingComponent(props) {
  var force = props.force,
      isPad = props.isPad,
      text = props.text;
  return createElement("div", {
    className: classnames('ph-loading', {
      'is-pad': isPad,
      'info-loading': text
    })
  }, createElement("div", {
    className: "loading-wrapper"
  }, createElement(Loading, {
    force: force
  }), text && createElement("p", {
    className: "loading-text"
  }, text)));
};

var index = new (
/*#__PURE__*/
function () {
  function Loading() {
    _classCallCheck(this, Loading);

    this.loadingEl = null;
    this.counter = 0;
  }

  _createClass(Loading, [{
    key: "clear",
    value: function clear() {
      var loadingEl = this.loadingEl;

      if (loadingEl) {
        this.loadingEl = null;
        document.body.removeChild(loadingEl);
        this.counter = 0;
      }
    }
  }, {
    key: "show",
    value: function show(text, force) {
      var isPad = getIsPadDisplay();

      if (this.counter <= 0) {
        this.loadingEl = this.addNode(createElement(LoadingComponent, {
          isPad: isPad,
          force: force,
          text: text
        }));
      }

      this.counter++;
    }
  }, {
    key: "hide",
    value: function hide() {
      var loadingEl = this.loadingEl,
          counter = this.counter;

      if (loadingEl && counter <= 1) {
        document.body.removeChild(loadingEl);
        this.loadingEl = null;
      }

      if (counter > 0) this.counter--;
    }
  }, {
    key: "addNode",
    value: function addNode(element) {
      var div = document.createElement('div');
      document.body.appendChild(div);
      ReactDOM.render(element, div);
      return div;
    }
  }]);

  return Loading;
}())();

export default index;
