import React, { PureComponent } from 'react';

function _classCallCheck(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
}

function _defineProperties(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || false;
    descriptor.configurable = true;
    if ("value" in descriptor) descriptor.writable = true;
    Object.defineProperty(target, descriptor.key, descriptor);
  }
}

function _createClass(Constructor, protoProps, staticProps) {
  if (protoProps) _defineProperties(Constructor.prototype, protoProps);
  if (staticProps) _defineProperties(Constructor, staticProps);
  return Constructor;
}

function _inherits(subClass, superClass) {
  if (typeof superClass !== "function" && superClass !== null) {
    throw new TypeError("Super expression must either be null or a function");
  }

  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      writable: true,
      configurable: true
    }
  });
  if (superClass) _setPrototypeOf(subClass, superClass);
}

function _getPrototypeOf(o) {
  _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
    return o.__proto__ || Object.getPrototypeOf(o);
  };
  return _getPrototypeOf(o);
}

function _setPrototypeOf(o, p) {
  _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
    o.__proto__ = p;
    return o;
  };

  return _setPrototypeOf(o, p);
}

function _assertThisInitialized(self) {
  if (self === void 0) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }

  return self;
}

function _possibleConstructorReturn(self, call) {
  if (call && (typeof call === "object" || typeof call === "function")) {
    return call;
  }

  return _assertThisInitialized(self);
}

// tslint:disable-next-line
var LONG_TOUCH_DURATION = 700;
var MAX_MOVE = 5;

var LongTouch =
/*#__PURE__*/
function (_PureComponent) {
  _inherits(LongTouch, _PureComponent);

  function LongTouch() {
    var _this;

    _classCallCheck(this, LongTouch);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(LongTouch).apply(this, arguments));
    _this.touchTimer = null;
    _this.touchX = 0;
    _this.touchY = 0;

    _this.onTouchStart = function (e) {
      var _e$touches$ = e.touches[0],
          pageX = _e$touches$.pageX,
          pageY = _e$touches$.pageY;
      _this.touchX = pageX;
      _this.touchY = pageY;
      _this.touchTimer = Date.now();
    };

    _this.onTouchEnd = function (e) {
      var touchDuration = Date.now() - _this.touchTimer;

      var _e$changedTouches$ = e.changedTouches[0],
          pageX = _e$changedTouches$.pageX,
          pageY = _e$changedTouches$.pageY;
      var onLongTouch = _this.props.onLongTouch;

      var _assertThisInitialize = _assertThisInitialized(_this),
          touchX = _assertThisInitialize.touchX,
          touchY = _assertThisInitialize.touchY;

      var isMove = pageX - touchX > MAX_MOVE || touchX - pageX > MAX_MOVE || pageY - touchY > MAX_MOVE || touchY - pageY > MAX_MOVE;

      if (touchDuration > LONG_TOUCH_DURATION && onLongTouch && !isMove) {
        onLongTouch();
      }
    };

    return _this;
  }

  _createClass(LongTouch, [{
    key: "render",
    value: function render() {
      return React.createElement("div", {
        onTouchStart: this.onTouchStart,
        onTouchEnd: this.onTouchEnd,
        onTouchCancel: this.onTouchEnd
      }, this.props.children);
    }
  }]);

  return LongTouch;
}(PureComponent);

export default LongTouch;
