import React__default, { createElement, Component } from 'react';
import bard from '@lls/bard';
import UserAgent from '@lls/client-js/es/UserAgent';
import classnames from 'classnames';
import ReactDOM from 'react-dom';
import FontFaceObserver from 'fontfaceobserver';

function _typeof(obj) {
  if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
    _typeof = function (obj) {
      return typeof obj;
    };
  } else {
    _typeof = function (obj) {
      return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
    };
  }

  return _typeof(obj);
}

function _classCallCheck(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
}

function _defineProperties(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || false;
    descriptor.configurable = true;
    if ("value" in descriptor) descriptor.writable = true;
    Object.defineProperty(target, descriptor.key, descriptor);
  }
}

function _createClass(Constructor, protoProps, staticProps) {
  if (protoProps) _defineProperties(Constructor.prototype, protoProps);
  if (staticProps) _defineProperties(Constructor, staticProps);
  return Constructor;
}

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

function _extends() {
  _extends = Object.assign || function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];

      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }

    return target;
  };

  return _extends.apply(this, arguments);
}

function _objectSpread(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i] != null ? arguments[i] : {};
    var ownKeys = Object.keys(source);

    if (typeof Object.getOwnPropertySymbols === 'function') {
      ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) {
        return Object.getOwnPropertyDescriptor(source, sym).enumerable;
      }));
    }

    ownKeys.forEach(function (key) {
      _defineProperty(target, key, source[key]);
    });
  }

  return target;
}

function _inherits(subClass, superClass) {
  if (typeof superClass !== "function" && superClass !== null) {
    throw new TypeError("Super expression must either be null or a function");
  }

  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      writable: true,
      configurable: true
    }
  });
  if (superClass) _setPrototypeOf(subClass, superClass);
}

function _getPrototypeOf(o) {
  _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
    return o.__proto__ || Object.getPrototypeOf(o);
  };
  return _getPrototypeOf(o);
}

function _setPrototypeOf(o, p) {
  _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
    o.__proto__ = p;
    return o;
  };

  return _setPrototypeOf(o, p);
}

function _objectWithoutPropertiesLoose(source, excluded) {
  if (source == null) return {};
  var target = {};
  var sourceKeys = Object.keys(source);
  var key, i;

  for (i = 0; i < sourceKeys.length; i++) {
    key = sourceKeys[i];
    if (excluded.indexOf(key) >= 0) continue;
    target[key] = source[key];
  }

  return target;
}

function _objectWithoutProperties(source, excluded) {
  if (source == null) return {};

  var target = _objectWithoutPropertiesLoose(source, excluded);

  var key, i;

  if (Object.getOwnPropertySymbols) {
    var sourceSymbolKeys = Object.getOwnPropertySymbols(source);

    for (i = 0; i < sourceSymbolKeys.length; i++) {
      key = sourceSymbolKeys[i];
      if (excluded.indexOf(key) >= 0) continue;
      if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;
      target[key] = source[key];
    }
  }

  return target;
}

function _assertThisInitialized(self) {
  if (self === void 0) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }

  return self;
}

function _possibleConstructorReturn(self, call) {
  if (call && (typeof call === "object" || typeof call === "function")) {
    return call;
  }

  return _assertThisInitialized(self);
}

function _slicedToArray(arr, i) {
  return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest();
}

function _arrayWithHoles(arr) {
  if (Array.isArray(arr)) return arr;
}

function _iterableToArrayLimit(arr, i) {
  var _arr = [];
  var _n = true;
  var _d = false;
  var _e = undefined;

  try {
    for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
      _arr.push(_s.value);

      if (i && _arr.length === i) break;
    }
  } catch (err) {
    _d = true;
    _e = err;
  } finally {
    try {
      if (!_n && _i["return"] != null) _i["return"]();
    } finally {
      if (_d) throw _e;
    }
  }

  return _arr;
}

function _nonIterableRest() {
  throw new TypeError("Invalid attempt to destructure non-iterable instance");
}

// tslint:disable-next-line
var PHONE_WIDTH_LIST = [375, 750, 1125]; // tslint:disable-next-line

var PAD_WIDTH_LIST = [1024, 2048, 3072];
var PHONE_RATIO = 37.5;
var PAD_RATIO = 102.4;
var LONG_TOUCH_DURATION = 700;
var MAX_MOVE = 5;

function getDPR() {
  var dpr = Math.floor(window.devicePixelRatio) || 1;
  if (dpr > 3) dpr = 3;
  if (dpr < 1) dpr = 1;
  return dpr;
}

var Imager =
/*#__PURE__*/
function (_React$Component) {
  _inherits(Imager, _React$Component);

  function Imager() {
    var _this;

    _classCallCheck(this, Imager);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(Imager).apply(this, arguments));
    _this.dpr = getDPR();
    _this.container = null;
    _this.touchTimer = null;
    _this.touchX = 0;
    _this.touchY = 0;

    _this.onTouchStart = function (e) {
      var _e$touches$ = e.touches[0],
          pageX = _e$touches$.pageX,
          pageY = _e$touches$.pageY;
      _this.touchX = pageX;
      _this.touchY = pageY;
      _this.touchTimer = Date.now();
    };

    _this.onTouchEnd = function (e) {
      var touchDuration = Date.now() - _this.touchTimer;

      var _e$changedTouches$ = e.changedTouches[0],
          pageX = _e$changedTouches$.pageX,
          pageY = _e$changedTouches$.pageY;
      var onLongTouch = _this.props.onLongTouch;

      var _assertThisInitialize = _assertThisInitialized(_this),
          touchX = _assertThisInitialize.touchX,
          touchY = _assertThisInitialize.touchY;

      var isMove = pageX - touchX > MAX_MOVE || touchX - pageX > MAX_MOVE || pageY - touchY > MAX_MOVE || touchY - pageY > MAX_MOVE;

      if (touchDuration > LONG_TOUCH_DURATION && onLongTouch && !isMove) {
        onLongTouch();
      }
    };

    return _this;
  }

  _createClass(Imager, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      this.initImage();
    }
  }, {
    key: "initImage",
    value: function initImage() {
      var _this2 = this;

      var _this$props = this.props,
          imgList = _this$props.imgList,
          onSuccess = _this$props.onSuccess,
          onFailure = _this$props.onFailure;
      var sequence = Promise.resolve();
      imgList.forEach(function (listItem, index) {
        sequence = sequence.then(function () {
          return _this2.createImage(listItem, index);
        });
      });
      sequence.then(onSuccess, onFailure);
    }
  }, {
    key: "createImage",
    value: function createImage(listItem, index) {
      var dpr = this.dpr,
          props = this.props,
          container = this.container;
      var widthList = props.widthList,
          onClick = props.onClick,
          useDivInner = props.useDivInner,
          isPad = props.isPad;
      var height = listItem.height,
          divInner = listItem.divInner;
      var isDivInner = typeof divInner === 'undefined' ? useDivInner : divInner;
      return new Promise(function (resolve, reject) {
        var box = document.createElement('div');
        box.className = 'imager-container';
        if (height) box.style.height = height;
        if (container) container.appendChild(box);
        var nodeType = isDivInner ? 'div' : 'img';
        var imgEl = document.createElement(nodeType);
        imgEl.className = 'imager-inner';

        if (onClick) {
          imgEl.addEventListener('click', function (event) {
            onClick(event, listItem, index);
          });
        }

        var list = widthList && widthList.length ? widthList : isPad ? PAD_WIDTH_LIST : PHONE_WIDTH_LIST;
        var resource = new Image();
        var miniImg = listItem[list[0]];
        var suitableImg = listItem[list[dpr - 1]];

        resource.onload = function () {
          box.style.backgroundImage = "url(".concat(miniImg, ")");
          box.style.backgroundSize = "100% 100%";

          if (isDivInner) {
            imgEl.style.backgroundImage = "url(".concat(suitableImg, ")");
          } else {
            var el = imgEl;
            el.src = suitableImg;
            el.style.height = height;
          }

          box.appendChild(imgEl);
          resolve();
        };

        resource.onerror = function (err) {
          reject(err);
        };

        resource.src = miniImg;
      });
    }
  }, {
    key: "render",
    value: function render() {
      var _this3 = this;

      var _this$props2 = this.props,
          className = _this$props2.className,
          isPad = _this$props2.isPad;
      return createElement("div", {
        onTouchStart: this.onTouchStart,
        onTouchEnd: this.onTouchEnd,
        onTouchCancel: this.onTouchEnd,
        ref: function ref(el) {
          return _this3.container = el;
        },
        className: classnames('ph-imager', className, {
          'is-pad': isPad
        })
      });
    }
  }]);

  return Imager;
}(Component);
Imager.defaultProps = {
  className: '',
  onSuccess: function onSuccess() {},
  onFailure: function onFailure() {}
};

var PHONE_IMAGE = [{
  375: 'https://cdn.llscdn.com/phonics-ui/phone-empty.png',
  750: 'https://cdn.llscdn.com/phonics-ui/phone-empty@2x.png',
  1125: 'https://cdn.llscdn.com/phonics-ui/phone-empty@3x.png',
  height: "".concat(168 / PHONE_RATIO, "rem")
}];
var PAD_IMAGE = [{
  1024: 'https://cdn.llscdn.com/phonics-ui/phone-empty@3x.png',
  2048: 'https://cdn.llscdn.com/phonics-ui/phone-empty@3x.png',
  3072: 'https://cdn.llscdn.com/phonics-ui/phone-empty@3x.png',
  height: "".concat(168 / PAD_RATIO, "rem")
}];

function reload() {
  window.location.reload();
}

function PageFail(props) {
  var isPad = props.isPad,
      className = props.className;
  return React__default.createElement("div", {
    className: classnames('ph-page-fail', className, {
      'is-pad': isPad
    })
  }, React__default.createElement(Imager, {
    className: "fail-image",
    isPad: isPad,
    imgList: isPad ? PAD_IMAGE : PHONE_IMAGE
  }), React__default.createElement("p", {
    className: "fail-text"
  }, "\u52A0\u8F7D\u5931\u8D25"), React__default.createElement("button", {
    className: "reload-btn",
    onClick: reload
  }, "\u91CD\u65B0\u52A0\u8F7D"));
}

var PHONE_IMAGE$1 = [{
  375: 'https://cdn.llscdn.com/sprout/assets/invalidName_phone.png',
  750: 'https://cdn.llscdn.com/sprout/assets/invalidName_phone@2x.png',
  1125: 'https://cdn.llscdn.com/sprout/assets/invalidName_phone@3x.png',
  height: "".concat(62 / PHONE_RATIO, "rem")
}];
var PAD_IMAGE$1 = [{
  1024: 'https://cdn.llscdn.com/sprout/assets/invalidName_pad.png',
  2048: 'https://cdn.llscdn.com/sprout/assets/invalidName_pad@2x.png',
  3072: 'https://cdn.llscdn.com/sprout/assets/invalidName_pad@3x.png',
  height: "".concat(68 / PAD_RATIO, "rem")
}];
function PageLoading(props) {
  var _ref = props || {},
      _ref$isPad = _ref.isPad,
      isPad = _ref$isPad === void 0 ? false : _ref$isPad,
      _ref$className = _ref.className,
      className = _ref$className === void 0 ? '' : _ref$className;

  return React__default.createElement("div", {
    className: classnames('ph-page-loading', className, {
      'is-pad': isPad
    })
  }, React__default.createElement(Imager, {
    className: "loading-image",
    isPad: isPad,
    imgList: isPad ? PAD_IMAGE$1 : PHONE_IMAGE$1
  }), React__default.createElement("div", {
    className: "loading-text"
  }, "\u52AA\u529B\u52A0\u8F7D\u4E2D"));
}
function PageLoading$1 (props) {
  var loadingEl;
  return {
    show: function show() {
      var div = document.createElement('div');
      document.body.appendChild(div);
      ReactDOM.render(React__default.createElement(PageLoading, _extends({}, props)), div);
      loadingEl = div;
    },
    hide: function hide() {
      if (loadingEl) document.body.removeChild(loadingEl);
      loadingEl = null;
    }
  };
}

var token = '%[a-f0-9]{2}';
var singleMatcher = new RegExp(token, 'gi');
var multiMatcher = new RegExp('(' + token + ')+', 'gi');

function decodeComponents(components, split) {
  try {
    // Try to decode the entire string first
    return decodeURIComponent(components.join(''));
  } catch (err) {// Do nothing
  }

  if (components.length === 1) {
    return components;
  }

  split = split || 1; // Split the array in 2 parts

  var left = components.slice(0, split);
  var right = components.slice(split);
  return Array.prototype.concat.call([], decodeComponents(left), decodeComponents(right));
}

function decode(input) {
  try {
    return decodeURIComponent(input);
  } catch (err) {
    var tokens = input.match(singleMatcher);

    for (var i = 1; i < tokens.length; i++) {
      input = decodeComponents(tokens, i).join('');
      tokens = input.match(singleMatcher);
    }

    return input;
  }
}

function customDecodeURIComponent(input) {
  // Keep track of all the replacements and prefill the map with the `BOM`
  var replaceMap = {
    '%FE%FF': "\uFFFD\uFFFD",
    '%FF%FE': "\uFFFD\uFFFD"
  };
  var match = multiMatcher.exec(input);

  while (match) {
    try {
      // Decode as big chunks as possible
      replaceMap[match[0]] = decodeURIComponent(match[0]);
    } catch (err) {
      var result = decode(match[0]);

      if (result !== match[0]) {
        replaceMap[match[0]] = result;
      }
    }

    match = multiMatcher.exec(input);
  } // Add `%C2` at the end of the map to make sure it does not replace the combinator before everything else


  replaceMap['%C2'] = "\uFFFD";
  var entries = Object.keys(replaceMap);

  for (var i = 0; i < entries.length; i++) {
    // Replace all decoded components
    var key = entries[i];
    input = input.replace(new RegExp(key, 'g'), replaceMap[key]);
  }

  return input;
}

var decodeUriComponent = function decodeUriComponent(encodedURI) {
  if (typeof encodedURI !== 'string') {
    throw new TypeError('Expected `encodedURI` to be of type `string`, got `' + _typeof(encodedURI) + '`');
  }

  try {
    encodedURI = encodedURI.replace(/\+/g, ' '); // Try the built in decoder first

    return decodeURIComponent(encodedURI);
  } catch (err) {
    // Fallback to a more advanced decoder
    return customDecodeURIComponent(encodedURI);
  }
};

var splitOnFirst = function splitOnFirst(string, separator) {
  if (!(typeof string === 'string' && typeof separator === 'string')) {
    throw new TypeError('Expected the arguments to be of type `string`');
  }

  if (separator === '') {
    return [string];
  }

  var separatorIndex = string.indexOf(separator);

  if (separatorIndex === -1) {
    return [string];
  }

  return [string.slice(0, separatorIndex), string.slice(separatorIndex + separator.length)];
};

function parserForArrayFormat(options) {
  var result;

  switch (options.arrayFormat) {
    case 'index':
      return function (key, value, accumulator) {
        result = /\[(\d*)\]$/.exec(key);
        key = key.replace(/\[\d*\]$/, '');

        if (!result) {
          accumulator[key] = value;
          return;
        }

        if (accumulator[key] === undefined) {
          accumulator[key] = {};
        }

        accumulator[key][result[1]] = value;
      };

    case 'bracket':
      return function (key, value, accumulator) {
        result = /(\[\])$/.exec(key);
        key = key.replace(/\[\]$/, '');

        if (!result) {
          accumulator[key] = value;
          return;
        }

        if (accumulator[key] === undefined) {
          accumulator[key] = [value];
          return;
        }

        accumulator[key] = [].concat(accumulator[key], value);
      };

    case 'comma':
      return function (key, value, accumulator) {
        var isArray = typeof value === 'string' && value.split('').indexOf(',') > -1;
        var newValue = isArray ? value.split(',') : value;
        accumulator[key] = newValue;
      };

    default:
      return function (key, value, accumulator) {
        if (accumulator[key] === undefined) {
          accumulator[key] = value;
          return;
        }

        accumulator[key] = [].concat(accumulator[key], value);
      };
  }
}

function decode$1(value, options) {
  if (options.decode) {
    return decodeUriComponent(value);
  }

  return value;
}

function keysSorter(input) {
  if (Array.isArray(input)) {
    return input.sort();
  }

  if (_typeof(input) === 'object') {
    return keysSorter(Object.keys(input)).sort(function (a, b) {
      return Number(a) - Number(b);
    }).map(function (key) {
      return input[key];
    });
  }

  return input;
}

function extract(input) {
  var queryStart = input.indexOf('?');

  if (queryStart === -1) {
    return '';
  }

  return input.slice(queryStart + 1);
}

function parse(input, options) {
  options = _extends({
    decode: true,
    arrayFormat: 'none'
  }, options);
  var formatter = parserForArrayFormat(options); // Create an object with no prototype

  var ret = Object.create(null);

  if (typeof input !== 'string') {
    return ret;
  }

  input = input.trim().replace(/^[?#&]/, '');

  if (!input) {
    return ret;
  }

  var _iteratorNormalCompletion = true;
  var _didIteratorError = false;
  var _iteratorError = undefined;

  try {
    for (var _iterator = input.split('&')[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
      var param = _step.value;

      var _splitOnFirst = splitOnFirst(param.replace(/\+/g, ' '), '='),
          _splitOnFirst2 = _slicedToArray(_splitOnFirst, 2),
          key = _splitOnFirst2[0],
          value = _splitOnFirst2[1]; // Missing `=` should be `null`:
      // http://w3.org/TR/2012/WD-url-20120524/#collect-url-parameters


      value = value === undefined ? null : decode$1(value, options);
      formatter(decode$1(key, options), value, ret);
    }
  } catch (err) {
    _didIteratorError = true;
    _iteratorError = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion && _iterator.return != null) {
        _iterator.return();
      }
    } finally {
      if (_didIteratorError) {
        throw _iteratorError;
      }
    }
  }

  return Object.keys(ret).sort().reduce(function (result, key) {
    var value = ret[key];

    if (Boolean(value) && _typeof(value) === 'object' && !Array.isArray(value)) {
      // Sort object keys, not values
      result[key] = keysSorter(value);
    } else {
      result[key] = value;
    }

    return result;
  }, Object.create(null));
}

var parseUrl = function parseUrl(input, options) {
  var hashStart = input.indexOf('#');

  if (hashStart !== -1) {
    input = input.slice(0, hashStart);
  }

  return {
    url: input.split('?')[0] || '',
    query: parse(extract(input), options)
  };
};

function parseParams() {
  var url = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : window.location.href;
  return parseUrl(url).query;
}

var getType = function getType(v) {
  return Object.prototype.toString.call(v);
};
var isFunction = function isFunction(v) {
  return getType(v) === '[object Function]';
};
var isObject = function isObject(v) {
  return getType(v) === '[object Object]';
};
var getIsPadDisplay = function getIsPadDisplay() {
  return window.innerWidth >= 1024 && window.innerWidth > window.innerHeight;
};
var noop = function noop() {};
function loadPrimaryFont() {
  var el = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : document.body;
  var FONT_LOAD_MAX_TIME = 30000;
  var FONT_NAME = 'FZY4JW';
  var font = new FontFaceObserver(FONT_NAME);
  font.load(null, FONT_LOAD_MAX_TIME).then(function () {
    el.style.fontFamily = FONT_NAME;
  }, noop);
}
var toArray = function toArray(target) {
  return Array.prototype.slice.call(target);
};
var preloadImage = function preloadImage(imgList) {
  return Promise.all(imgList.map(loadImage));
};
var loadImage = function loadImage(imgSrc) {
  return new Promise(function (resolve, reject) {
    var img = new Image();
    img.src = imgSrc;

    img.onload = function () {
      resolve();
    };

    img.onerror = function () {
      reject();
    };
  });
};

function setGangFour(_ref) {
  var deviceId = _ref.deviceId,
      sDeviceId = _ref.sDeviceId,
      token = _ref.token,
      appId = _ref.appId,
      userLogin = _ref.userLogin;
  localStorage.setItem('TOKEN', JSON.stringify(token));
  localStorage.setItem('APP_ID', JSON.stringify(appId));
  localStorage.setItem('DEVICE_ID', JSON.stringify(deviceId));
  localStorage.setItem('S_DEVICE_ID', JSON.stringify(sDeviceId));
  localStorage.setItem('USER_LOGIN', JSON.stringify(userLogin));
}

function getVisibilityName() {
  var hidden = '';
  var visibilityChange = '';

  if (typeof document.hidden !== 'undefined') {
    hidden = 'hidden';
    visibilityChange = 'visibilitychange';
  } else if (typeof document.msHidden !== 'undefined') {
    hidden = 'msHidden';
    visibilityChange = 'msvisibilitychange';
  } else if (typeof document.webkitHidden !== 'undefined') {
    hidden = 'webkitHidden';
    visibilityChange = 'webkitvisibilitychange';
  }

  return {
    hidden: hidden,
    visibilityChange: visibilityChange
  };
}

var _getVisibilityName = getVisibilityName(),
    hidden = _getVisibilityName.hidden,
    visibilityChange = _getVisibilityName.visibilityChange;

function PageWrapper(target) {
  // TODO: fix type
  var usePrimaryFont = false;
  var notJudgePad = false;
  var useAuthInApp = false;
  var preloadSync = false;
  var preload = [];

  function getAppAuth() {
    var _parseParams = parseParams(),
        deviceId = _parseParams.deviceId,
        sDeviceId = _parseParams.sDeviceId,
        token = _parseParams.token,
        appId = _parseParams.appId;

    if (deviceId && sDeviceId && token && appId) {
      var result = {
        deviceId: deviceId,
        sDeviceId: sDeviceId,
        token: token,
        appId: appId,
        userLogin: ''
      };
      setGangFour(result);
      return Promise.resolve(result);
    } else if (UserAgent.isHybrid) {
      return bard.invoke('getAuthData').then(function (_ref2) {
        var deviceId = _ref2.deviceId,
            sDeviceId = _ref2.sDeviceId,
            token = _ref2.token,
            appId = _ref2.appId,
            userLogin = _ref2.userLogin;
        var result = {
          deviceId: deviceId,
          sDeviceId: sDeviceId,
          token: token,
          appId: appId,
          userLogin: userLogin
        };
        setGangFour(result);
        return result;
      });
    } else {
      return Promise.resolve();
    }
  }

  var pageHoc = function pageHoc(OriginComponent) {
    var hasFetch = isFunction(OriginComponent.fetch);

    var PhPageWrapper =
    /*#__PURE__*/
    function (_Component) {
      _inherits(PhPageWrapper, _Component);

      function PhPageWrapper() {
        var _this;

        _classCallCheck(this, PhPageWrapper);

        _this = _possibleConstructorReturn(this, _getPrototypeOf(PhPageWrapper).apply(this, arguments));
        _this.state = {
          loading: hasFetch || useAuthInApp || !!preload.length,
          auth: null,
          data: null,
          error: null
        };
        _this.isPad = getIsPadDisplay();

        _this.onOrientationChange = function () {
          window.location.reload();
        };

        return _this;
      }

      _createClass(PhPageWrapper, [{
        key: "componentWillMount",
        value: function componentWillMount() {
          var _this2 = this;

          if (usePrimaryFont) loadPrimaryFont();
          var showLoading = this.state.loading;
          if (!showLoading) return;
          var isPad = this.isPad;
          var loading = PageLoading$1({
            isPad: isPad
          });
          loading.show();
          var auth = null;
          var data = null;
          var authPromise = useAuthInApp ? getAppAuth() : Promise.resolve(null);
          var loadImage = preloadImage(preload).catch(function (_) {
            return _;
          });
          var imgPromise = preloadSync ? loadImage : Promise.resolve(null);
          Promise.all([authPromise, imgPromise]).then(function (_ref3) {
            var _ref4 = _slicedToArray(_ref3, 1),
                res = _ref4[0];

            if (res) auth = res;

            if (hasFetch) {
              return OriginComponent.fetch(_objectSpread({}, _this2.props, {
                auth: res
              })).then(function (d) {
                return data = d;
              });
            }
          }).then(function () {
            _this2.setState({
              data: data,
              auth: auth,
              loading: false
            });

            loading.hide();
          }).catch(function (err) {
            _this2.setState({
              error: err || true,
              loading: false
            });

            loading.hide();
          });
        }
      }, {
        key: "handleVChange",
        value: function handleVChange() {
          var videos = toArray(document.querySelectorAll('video'));
          var audios = toArray(document.querySelectorAll('audio'));

          if (document[hidden]) {
            videos.forEach(function (video) {
              video.pause();
            });
            audios.forEach(function (audio) {
              audio.pause();
            });
          }
        }
      }, {
        key: "componentDidMount",
        value: function componentDidMount() {
          document.addEventListener(visibilityChange, this.handleVChange);

          if (!notJudgePad) {
            if (this.isPad) document.body.classList.add('ph-pad-body');
            window.addEventListener('orientationchange', this.onOrientationChange);
          }
        }
      }, {
        key: "componentWillUnmount",
        value: function componentWillUnmount() {
          document.addEventListener(visibilityChange, this.handleVChange);

          if (!notJudgePad) {
            window.removeEventListener('orientationchange', this.onOrientationChange);
          }
        }
      }, {
        key: "render",
        value: function render() {
          var _this$state = this.state,
              loading = _this$state.loading,
              data = _this$state.data,
              error = _this$state.error,
              auth = _this$state.auth;
          var jest = this.props.jest;

          if (jest) {
            var _this$props = this.props,
                _jest = _this$props.jest,
                _props = _objectWithoutProperties(_this$props, ["jest"]);

            return React__default.createElement(OriginComponent, _extends({}, _props));
          }

          if (loading) return null;
          if (error) return React__default.createElement(PageFail, {
            isPad: this.isPad
          });

          var props = _objectSpread({
            data: data
          }, this.props, {
            auth: auth
          });

          if (!notJudgePad) props.isPad = this.isPad;
          return React__default.createElement(OriginComponent, _extends({}, props));
        }
      }]);

      return PhPageWrapper;
    }(Component);

    return PhPageWrapper;
  };

  if (target && target.prototype instanceof Component) {
    return pageHoc(target);
  } else {
    if (isObject(target)) {
      usePrimaryFont = !!target.usePrimaryFont;
      notJudgePad = !!target.notJudgePad;
      useAuthInApp = !!target.useAuthInApp;
      preload = target.preload || [];
      preloadSync = target.preloadSync;
    }

    return pageHoc;
  }
}

export default PageWrapper;
