import classnames from 'classnames';
import React, { PureComponent } from 'react';
import ReactDOM from 'react-dom';
import 'fontfaceobserver';

function _typeof(obj) {
  if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
    _typeof = function (obj) {
      return typeof obj;
    };
  } else {
    _typeof = function (obj) {
      return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
    };
  }

  return _typeof(obj);
}

function _classCallCheck(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
}

function _defineProperties(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || false;
    descriptor.configurable = true;
    if ("value" in descriptor) descriptor.writable = true;
    Object.defineProperty(target, descriptor.key, descriptor);
  }
}

function _createClass(Constructor, protoProps, staticProps) {
  if (protoProps) _defineProperties(Constructor.prototype, protoProps);
  if (staticProps) _defineProperties(Constructor, staticProps);
  return Constructor;
}

function _inherits(subClass, superClass) {
  if (typeof superClass !== "function" && superClass !== null) {
    throw new TypeError("Super expression must either be null or a function");
  }

  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      writable: true,
      configurable: true
    }
  });
  if (superClass) _setPrototypeOf(subClass, superClass);
}

function _getPrototypeOf(o) {
  _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
    return o.__proto__ || Object.getPrototypeOf(o);
  };
  return _getPrototypeOf(o);
}

function _setPrototypeOf(o, p) {
  _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
    o.__proto__ = p;
    return o;
  };

  return _setPrototypeOf(o, p);
}

function _assertThisInitialized(self) {
  if (self === void 0) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }

  return self;
}

function _possibleConstructorReturn(self, call) {
  if (call && (typeof call === "object" || typeof call === "function")) {
    return call;
  }

  return _assertThisInitialized(self);
}

var getIsPadDisplay = function getIsPadDisplay() {
  return window.innerWidth >= 1024 && window.innerWidth > window.innerHeight;
};

var noop = function noop() {};

var ShareNoticeComponent =
/*#__PURE__*/
function (_PureComponent) {
  _inherits(ShareNoticeComponent, _PureComponent);

  function ShareNoticeComponent() {
    var _this;

    _classCallCheck(this, ShareNoticeComponent);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(ShareNoticeComponent).apply(this, arguments));
    _this.state = {
      show: null
    };
    return _this;
  }

  _createClass(ShareNoticeComponent, [{
    key: "componentWillUpdate",
    value: function componentWillUpdate(_, state) {
      if (this.state.show !== false && state.show === false) {
        if (typeof this.props.onHide === 'function') {
          this.props.onHide();
        }
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props = this.props,
          isPad = _this$props.isPad,
          propShow = _this$props.show;
      if (!propShow) return '';
      var stateShow = this.state.show;
      var show = _typeof(stateShow) === 'object' && !stateShow ? true : stateShow;
      return show ? React.createElement("div", {
        className: "ph-share-notice",
        onClick: this.onClick.bind(this)
      }, "'is-ipad': isPad", React.createElement("div", {
        className: classnames('ph-share-mark-img', {})
      }), React.createElement("div", {
        className: classnames('ph-share-mark-texts', {
          'is-ipad': isPad
        })
      }, React.createElement("p", null, "\u70B9\u51FB\u53F3\u4E0A\u89D2\u56FE\u6807\uFF0C"), React.createElement("p", null, "\u9009\u62E9\u5206\u4EAB\u5230\u670B\u53CB\u5708"))) : '';
    }
  }, {
    key: "onClick",
    value: function onClick() {
      this.setState({
        show: false
      });
    }
  }]);

  return ShareNoticeComponent;
}(PureComponent);

var ShareNotice =
/*#__PURE__*/
function () {
  function ShareNotice() {
    var onHide = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : noop;

    _classCallCheck(this, ShareNotice);

    this.shareEl = null;
    this.propShow = true;
    this.onHide = onHide;
  }

  _createClass(ShareNotice, [{
    key: "show",
    value: function show() {
      this.propShow = true;
      var isPad = getIsPadDisplay();

      if (!this.shareEl) {
        this.shareEl = this.addNode(React.createElement(ShareNoticeComponent, {
          isPad: isPad,
          show: this.propShow,
          onHide: this.removeNode.bind(this)
        }));
      }
    }
  }, {
    key: "hide",
    value: function hide() {
      if (!this.shareEl) return;
      this.propShow = false;

      if (typeof this.onHide === 'function') {
        this.onHide();
      }

      this.removeNode(false);
    }
  }, {
    key: "removeNode",
    value: function removeNode() {
      var callOnHide = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : true;
      if (!this.shareEl) return;

      if (callOnHide) {
        this.onHide();
      } // tslint:disable-next-line: no-non-null-assertion


      this.shareEl.parentNode.removeChild(this.shareEl);
      this.shareEl = null;
    }
  }, {
    key: "addNode",
    value: function addNode(element) {
      var div = document.createElement('div');
      document.body.appendChild(div);
      ReactDOM.render(element, div);
      return div;
    }
  }], [{
    key: "show",
    value: function show() {
      new ShareNotice().show();
    }
  }]);

  return ShareNotice;
}();

export default ShareNotice;
