var Cache = {};
var SessionCache = {};

function _getStore(key, isSession) {
  try {
    var storeType = isSession ? 'sessionStorage' : 'localStorage';
    return JSON.parse(window[storeType].getItem(key));
  } catch (e) {}
}

function _setStore(key, value, isSession) {
  try {
    var storeType = isSession ? 'sessionStorage' : 'localStorage';
    window[storeType].setItem(key, JSON.stringify(value));
  } catch (e) {}
}

function _removeStore(key, isSession) {
  try {
    var storeType = isSession ? 'sessionStorage' : 'localStorage';
    window[storeType].removeItem(key);
  } catch (e) {}
}

function _clearStore(isSession) {
  try {
    var storeType = isSession ? 'sessionStorage' : 'localStorage';
    window[storeType].clear();
  } catch (e) {}
}

function getStore(key) {
  return Cache[key] !== undefined ? Cache[key] : Cache[key] = _getStore(key);
}
function setStore(key, value) {
  if (Cache[key] === value) return;

  _setStore(key, value);

  Cache[key] = value;
}
function removeStore(key) {
  _removeStore(key);

  delete Cache[key];
}
function clearStore() {
  _clearStore();

  Cache = {};
}
function getSessionStore(key) {
  return SessionCache[key] !== undefined ? SessionCache[key] : SessionCache[key] = _getStore(key, true);
}
function setSessionStore(key, value) {
  if (SessionCache[key] === value) return;

  _setStore(key, value, true);

  SessionCache[key] = value;
}
function removeSessionStore(key) {
  _removeStore(key, true);

  delete SessionCache[key];
}
function clearSessionStore() {
  _clearStore(true);

  SessionCache = {};
}
var index = {
  getStore: getStore,
  setStore: setStore,
  removeStore: removeStore,
  clearStore: clearStore,
  getSessionStore: getSessionStore,
  setSessionStore: setSessionStore,
  removeSessionStore: removeSessionStore,
  clearSessionStore: clearSessionStore
};

export default index;
export { clearSessionStore, clearStore, getSessionStore, getStore, removeSessionStore, removeStore, setSessionStore, setStore };
