import classnames from 'classnames';
import React__default, { createElement, PureComponent } from 'react';

function _classCallCheck(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
}

function _defineProperties(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || false;
    descriptor.configurable = true;
    if ("value" in descriptor) descriptor.writable = true;
    Object.defineProperty(target, descriptor.key, descriptor);
  }
}

function _createClass(Constructor, protoProps, staticProps) {
  if (protoProps) _defineProperties(Constructor.prototype, protoProps);
  if (staticProps) _defineProperties(Constructor, staticProps);
  return Constructor;
}

function _inherits(subClass, superClass) {
  if (typeof superClass !== "function" && superClass !== null) {
    throw new TypeError("Super expression must either be null or a function");
  }

  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      writable: true,
      configurable: true
    }
  });
  if (superClass) _setPrototypeOf(subClass, superClass);
}

function _getPrototypeOf(o) {
  _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
    return o.__proto__ || Object.getPrototypeOf(o);
  };
  return _getPrototypeOf(o);
}

function _setPrototypeOf(o, p) {
  _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
    o.__proto__ = p;
    return o;
  };

  return _setPrototypeOf(o, p);
}

function _assertThisInitialized(self) {
  if (self === void 0) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }

  return self;
}

function _possibleConstructorReturn(self, call) {
  if (call && (typeof call === "object" || typeof call === "function")) {
    return call;
  }

  return _assertThisInitialized(self);
}

var AVATAR_MAP = {
  male: 'https://cdn.llscdn.com/sprout/sprout-hybrid/avatar/imgBoy@3x.png',
  female: 'https://cdn.llscdn.com/sprout/sprout-hybrid/avatar/imgGirl@3x.png'
};
var DEFAULT_AVATAR = AVATAR_MAP.male;
var genderList;

(function (genderList) {
  genderList["male"] = "male";
  genderList["female"] = "female";
})(genderList || (genderList = {}));

Avatar.AVATAR_MAP = AVATAR_MAP;
function Avatar(props) {
  var className = props.className,
      url = props.url,
      gender = props.gender,
      isPad = props.isPad;
  var avatar = url || gender && AVATAR_MAP[gender] || DEFAULT_AVATAR;
  return createElement("div", {
    className: classnames('ph-avatar', className, {
      'is-pad': isPad
    })
  }, createElement("img", {
    src: avatar,
    alt: "avatar"
  }));
}

var Subtitle =
/*#__PURE__*/
function (_PureComponent) {
  _inherits(Subtitle, _PureComponent);

  function Subtitle() {
    var _this;

    _classCallCheck(this, Subtitle);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(Subtitle).apply(this, arguments));
    _this.state = {
      transiting: false,
      currentIndex: 0
    };
    _this.timeoutToken = null;
    _this.intervalToekn = null;
    _this.el = null;
    _this.visible = true;

    _this.terminateCurrentTransition = function () {
      _this.setState({
        transiting: false,
        currentIndex: _this.getNextIndex()
      });

      _this.scheduleNextTransition();
    };

    return _this;
  }

  _createClass(Subtitle, [{
    key: "scheduleNextTransition",
    value: function scheduleNextTransition() {
      var _this2 = this;

      this.timeoutToken = setTimeout(function () {
        _this2.setState({
          transiting: true
        });
      }, this.props.duration);
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this3 = this;

      if (this.props.watchVisible) {
        this.intervalToekn = setInterval(function () {
          var _this3$el$getBounding = _this3.el.getBoundingClientRect(),
              width = _this3$el$getBounding.width;

          if (width && !_this3.visible) {
            _this3.visible = true;

            _this3.terminateCurrentTransition();
          }

          if (!width && _this3.visible) {
            _this3.visible = false;
          }
        }, this.props.watchCheckDuration);
      }

      this.scheduleNextTransition();
    }
  }, {
    key: "getNextIndex",
    value: function getNextIndex() {
      var index = this.state.currentIndex;
      var nextIndex = index + 1;
      return nextIndex === this.props.textList.length ? 0 : nextIndex;
    }
  }, {
    key: "componentWillUnmount",
    value: function componentWillUnmount() {
      if (this.timeoutToken) clearTimeout(this.timeoutToken);
      if (this.props.watchVisible) clearInterval(this.intervalToekn);
    }
  }, {
    key: "render",
    value: function render() {
      var _this4 = this;

      var _this$props = this.props,
          rightText = _this$props.rightText,
          background = _this$props.background,
          textList = _this$props.textList,
          isPad = _this$props.isPad,
          className = _this$props.className;
      var _this$state = this.state,
          transiting = _this$state.transiting,
          currentIndex = _this$state.currentIndex;
      var num = rightText.num,
          text = rightText.text;
      var list = textList.slice(currentIndex, currentIndex + 2);
      if (list.length === 1) list.push(textList[0]);
      return React__default.createElement("div", {
        className: classnames('ph-subtitle', className, {
          'is-pad': isPad
        }),
        ref: function ref(el) {
          return _this4.el = el;
        },
        style: {
          background: background
        }
      }, React__default.createElement("div", {
        className: "main-container"
      }, React__default.createElement("div", {
        className: classnames('scroll-box', {
          transiting: transiting
        }),
        onTransitionEnd: this.terminateCurrentTransition
      }, list.map(function (_ref, index) {
        var name = _ref.name,
            text = _ref.text,
            gender = _ref.gender;
        return React__default.createElement("div", {
          key: index
        }, React__default.createElement("div", {
          className: "subtitle-column"
        }, React__default.createElement(Avatar, {
          gender: gender
        }), React__default.createElement("div", {
          className: "subtitle-name"
        }, name), React__default.createElement("div", {
          className: "subtitle-text"
        }, text)));
      }))), React__default.createElement("div", {
        className: "right-container"
      }, React__default.createElement("span", {
        className: "right-num"
      }, num), React__default.createElement("span", {
        className: "right-text"
      }, text)));
    }
  }]);

  return Subtitle;
}(PureComponent);
Subtitle.defaultProps = {
  background: '#9468D9',
  duration: 1000,
  watchCheckDuration: 100
};

export default Subtitle;
