import FontFaceObserver from 'fontfaceobserver';

var getType = function getType(v) {
  return Object.prototype.toString.call(v);
};
var isFunction = function isFunction(v) {
  return getType(v) === '[object Function]';
};
var isObject = function isObject(v) {
  return getType(v) === '[object Object]';
};
var getIsPadDisplay = function getIsPadDisplay() {
  return window.innerWidth >= 1024 && window.innerWidth > window.innerHeight;
};
var noop = function noop() {};
function loadPrimaryFont() {
  var el = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : document.body;
  var FONT_LOAD_MAX_TIME = 30000;
  var FONT_NAME = 'FZY4JW';
  var font = new FontFaceObserver(FONT_NAME);
  font.load(null, FONT_LOAD_MAX_TIME).then(function () {
    el.style.fontFamily = FONT_NAME;
  }, noop);
}
var toArray = function toArray(target) {
  return Array.prototype.slice.call(target);
};
var preloadImage = function preloadImage(imgList) {
  return Promise.all(imgList.map(loadImage));
};
var loadImage = function loadImage(imgSrc) {
  return new Promise(function (resolve, reject) {
    var img = new Image();
    img.src = imgSrc;

    img.onload = function () {
      resolve();
    };

    img.onerror = function () {
      reject();
    };
  });
};

export { getIsPadDisplay, getType, isFunction, isObject, loadImage, loadPrimaryFont, noop, preloadImage, toArray };
