/// <reference types="node" />
import './style.less';
import { PureComponent } from 'react';
import { genderList } from '../avatar/index';
interface RightText {
    num: number;
    text: string;
}
interface TextItem {
    name: string;
    text: string;
    gender: genderList;
}
export interface Props {
    textList: Array<TextItem>;
    rightText: RightText;
    background: string;
    duration: number;
    className?: string;
    isPad?: boolean;
    watchVisible?: boolean;
    watchCheckDuration?: number;
}
export default class Subtitle extends PureComponent<Props, object> {
    static defaultProps: {
        background: string;
        duration: number;
        watchCheckDuration: number;
    };
    state: {
        transiting: boolean;
        currentIndex: number;
    };
    timeoutToken: NodeJS.Timeout | null;
    intervalToekn: number | null;
    el: HTMLDivElement | null;
    visible: boolean;
    scheduleNextTransition(): void;
    componentDidMount(): void;
    getNextIndex(): number;
    terminateCurrentTransition: () => void;
    componentWillUnmount(): void;
    render(): JSX.Element;
}
export {};
